#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif /* HAVE_CONFIG_H */

#include "manconfig.h"

/* Flex emits several functions which might reasonably have various
 * attributes applied and many unused macros; none of these are our problem.
 */
#if GNUC_PREREQ(8,0)
#  pragma GCC diagnostic ignored "-Wsuggest-attribute=malloc"
#endif
#pragma GCC diagnostic ignored "-Wsuggest-attribute=pure"
#pragma GCC diagnostic ignored "-Wunused-macros"

#line 17 "lexgrog.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* begin standard C++ headers. */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = NULL;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart ( FILE *input_file  );
void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
void yy_delete_buffer ( YY_BUFFER_STATE b  );
void yy_flush_buffer ( YY_BUFFER_STATE b  );
void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state ( void );

static void yyensure_buffer_stack ( void );
static void yy_load_buffer_state ( void );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap() (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP
typedef flex_uint8_t YY_CHAR;

FILE *yyin = NULL, *yyout = NULL;

typedef int yy_state_type;

extern int yylineno;
int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
static int yy_get_next_buffer ( void );
static void yynoreturn yy_fatal_error ( const char* msg  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;
#define YY_NUM_RULES 139
#define YY_END_OF_BUFFER 140
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[1436] =
    {   0,
        0,    0,    0,    0,   65,   65,   65,   65,    0,    0,
        0,    0,    0,    0,    0,    0,  117,  117,    0,    0,
        0,    0,    0,    0,  124,  124,    8,    8,    0,    0,
        0,    0,    0,    0,    0,    0,  140,  139,   29,   29,
       29,  138,   65,   65,  138,  138,  138,  136,  138,  134,
       81,   65,   65,  138,   81,  104,  104,  104,   99,  104,
      106,  106,  105,  111,  111,  111,  110,  116,  116,  116,
      116,  116,  117,  119,  119,  118,  121,  121,  120,  123,
      123,  122,  124,  124,  138,  135,  138,  138,  138,    7,
       10,    7,    7,    6,    6,    6,    4,   18,   18,   18,

       19,   19,    0,   28,    0,   27,   27,   29,   65,    0,
      136,    0,    0,  137,   65,   65,  137,  133,  137,  137,
      133,   81,   65,    0,    0,  136,    0,  134,   68,   65,
       74,    0,   61,    0,    0,   63,   64,    0,    0,   60,
       62,   60,    0,    0,    0,    0,    0,    0,   65,    0,
       65,   65,  137,  133,   81,   65,    0,   63,  104,    0,
        0,   99,   92,   93,   94,   95,   96,   97,   98,  106,
      105,  111,    0,    0,    0,  110,  110,  116,    0,    0,
        0,  117,  119,  118,  121,  120,  123,  122,  124,  135,
        0,    0,  124,  124,  137,  137,  137,  137,  124,  135,

       54,    0,  124,   39,    7,    0,    9,    0,   10,    7,
        6,    0,    3,    4,    3,    4,    3,   18,    0,    0,
        0,   18,   19,   28,    0,    0,    0,   27,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   56,    0,   65,
        0,    0,   36,   36,   36,   36,   36,   36,   36,   36,
        0,   50,    0,    0,    0,    0,    0,    0,  128,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       48,    0,   56,   49,    0,   57,   74,   70,    0,    0,
        0,    0,    0,    0,    0,    0,   73,   73,   73,    0,
        0,    0,   67,    0,   75,   76,    0,   77,    0,    0,

       79,    0,    0,   65,    0,    0,   36,   36,   36,   36,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       91,  100,  101,  102,  103,   99,   92,   93,   94,   95,
       96,   97,   98,    0,    0,    0,    0,    0,    0,   59,
        0,  124,   38,   38,  124,   38,   38,   38,   38,   37,
       54,    7,    0,    0,    0,    9,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    7,    5,    3,    3,    4,    4,    4,    3,
        0,    0,    0,    0,    0,   16,    0,   21,   27,   27,
       27,   27,   20,   27,   27,   27,   56,    0,    0,    0,

       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   51,   41,
        0,    0,    0,    0,    0,  126,   58,    0,  128,   47,
      127,    0,    0,   30,    0,    0,    0,  125,   34,   53,
        0,   35,   33,   52,   32,   49,   82,   71,   61,   55,
       62,   66,    0,    0,    0,    0,    0,    0,    0,    0,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,

       36,   83,    0,   85,   90,   86,   87,   88,   89,   63,
       91,  100,  101,  102,  103,    0,    0,    0,  114,  112,
        0,   38,   38,   38,   38,   37,   38,   38,    7,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    7,    5,    3,    3,    4,    4,    4,
        0,    3,    3,   12,   14,   13,   15,   11,   17,   21,
       25,   26,   20,   22,   24,   23,   55,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   30,   36,   36,   36,   36,

       34,   36,   36,   35,   33,   36,   32,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   40,  130,  129,   45,  126,   58,   46,   47,
      127,  132,  131,   30,   42,   44,   31,  125,   34,   34,
       53,   43,   35,   33,   52,   32,   82,   55,   72,    0,
       69,   78,   80,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   83,   84,   85,   90,   86,   87,
       88,   89,    0,  108,    0,  114,  115,  112,  113,   38,
       38,    7,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        7,    3,    3,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        3,    3,   25,   26,   22,   24,   23,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   30,   36,   36,   31,   36,   34,   34,
       36,   36,   35,   33,   36,   32,   36,   36,   36,   36,

       36,   36,   36,   36,   36,   36,   36,  130,  129,   45,
      132,  131,   44,   43,   80,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   84,  107,  108,  109,  115,  113,
        7,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    7,    3,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    3,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,  107,  109,    7,
        0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    7,    3,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,

        4,    4,    4,    1,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    4,    1,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    0,    1,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    1,    0,    1,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    3,   36,    7,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    7,    3,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,

        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    1,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    1,    4,    1,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    1,
        1,    4,    4,    4,    4,    4,    4,    1,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    0,    1,    1,    0,    0,    0,
        0,    0,    0,    1,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        3,    7,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    7,    3,
        3,    4,    4,    1,    0,    1,    0,    0,    0,    0,
        0,    0,    0,    0,    1,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    3,    3,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    8,    0,
        0,    1,    0,    1,    0,    0,    0,    0,    0,    1,
        1,    0,    0,    0,    0,    1,    1,    1,    0,    1,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        0,    0,    0,    0,    0,    1,    0,    1,    0,    0,
        0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    0,    0,    0,    0,    0,    1,
        1,    0,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    0,    0,    0,    0,    1,    1,    1,    1,    1,
        1,    0,    0,    0,    0,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    0,    0,    0,
        0,    1,    1,    1,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    8,    9,    6,   10,   11,   12,
       13,   14,   15,   16,   17,   18,    1,   19,   20,   21,
       22,   23,   24,   25,   26,   27,   27,    1,    1,    1,
        1,    1,    1,    1,   28,   29,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
       54,   55,   56,    6,   57,   58,   59,   60,   61,   62,

       63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
       73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
       83,   84,    6,   85,    6,   86,    1,    1,   87,    1,
        1,   88,   89,   90,    1,    1,   91,   92,    1,    1,
       93,    1,    1,   94,   95,   96,    1,    1,   97,    1,
       98,   99,    1,    1,    1,  100,  101,  102,    1,    1,
      103,    1,    1,  104,    1,  105,  106,  107,  108,  109,
        1,    1,  110,  111,  112,  113,  114,    1,    1,  115,
        1,    1,    1,    1,  116,    1,  117,    1,  118,  119,
        1,    1,    1,    1,  120,  121,    1,    1,    1,    1,

        1,    1,    1,  122,    1,    1,    1,  123,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,  124,    1,    1,    1,  125,  126,    1,
      127,    1,    1,    1,  128,  129,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[130] =
    {   0,
        1,    2,    3,    4,    2,    1,    5,    1,    1,    1,
        6,    7,    1,    1,    1,    1,    1,    1,    8,    9,
        9,    9,    9,    8,    8,    8,    8,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,    1,    1,    1,    1,    1,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1
    } ;

static const flex_int16_t yy_base[1619] =
    {   0,
        0,    0,    0,    2,    6,    0,  134,  138,  141,  142,
      222,    0,  351,    0,  140,  477, 5190, 5188,  555,    0,
      684,    0,  813,    0,  145,  154,  149,  162,  164,  165,
        0,    0,  169,  174, 5186, 5185, 5188, 7311, 7311,  194,
     5184, 7311,  480,  487,  941, 5131, 5130,  179, 5166,    0,
      994,  952,  959, 5178,  189, 7311, 5177, 5131,  190,  486,
     7311, 5148,    0, 7311, 5147,  155,  202, 7311, 5146, 5077,
     5080, 5083,    0, 7311, 5138,    0, 7311, 5137,    0, 7311,
     5136,    0,  964,  970, 5135,  498,  216, 5130, 5077,    0,
      515, 5130, 5127, 7311, 5128, 5075,  982,    0,  510, 5126,

     7311, 5125,  527,  522, 5124,    0, 1048,  534, 1027, 1083,
      539, 5109,  948, 7311, 1099, 1103, 1124, 5070, 5069, 5106,
     1178,  938, 1131, 5115, 5036,  541,  546,    0, 7311,  954,
        0, 1139, 7311, 1111,  937,  945, 7311,  974,    0, 5042,
     7311, 7311, 5107,    0, 5106, 5110, 1178,  982, 1151, 1005,
     1037, 1249, 5113, 1215, 1161, 1266, 1216, 7311, 7311, 5035,
     1000, 1189, 1013, 1033, 1045, 1060, 1094, 1108, 1117, 7311,
        0, 7311, 5044, 5050, 5049, 1135, 1142, 7311, 5033, 5038,
     5043,    0, 7311,    0, 7311,    0, 7311,    0, 1257, 1232,
     1286, 5094, 1167, 1294, 5094, 1248, 5090, 5037, 1304, 1311,

     1315, 5090, 1281, 7311,    0, 1320, 1339, 5089, 1324, 5086,
     7311, 5083, 5082, 5080, 5078, 1325, 5077,    0, 1114, 5053,
     1320, 1127, 7311, 7311, 5052, 1335, 5051,    0, 1328, 1343,
     4982,  457, 1349, 4976, 1092, 4969, 1346, 1183, 1239, 1414,
     1431, 1435, 5043, 1439, 1468,  991, 1014,  157, 1522, 1597,
     1332, 7311, 5042, 1385, 5001, 1448, 5000,  132, 1187, 1367,
     1449, 4970, 1168,    0, 4963, 4975,  456, 1201, 4973, 1462,
     7311, 5024, 1353,    0, 5022, 1364,    0, 7311,    0, 4975,
      416, 4974, 4949, 4964, 4951, 4959, 7311,    0,    0, 1409,
        0,    0, 7311,    0, 7311, 7311,    0, 7311,    0, 1598,

     7311, 1444,    0, 1478,  491, 5025, 1402, 5024, 1682, 1757,
     4948, 1498, 4950, 4942, 1027, 4941, 4940,  478, 4938, 4953,
     1420, 1422, 1449, 1474, 1500, 1502, 1504, 1508, 1514, 1515,
     1516, 1533, 1539, 4945, 4940, 4937, 4953, 4942, 4941, 1544,
     1550, 1557,    0, 1574, 1593, 5010, 1581, 4998, 4942, 7311,
     1638,    0, 1842, 4995, 1851, 1864, 4993,  919, 4955, 1168,
     1184, 1680, 4966, 4871, 4943, 4873, 4866,   87, 4871, 1029,
     4872, 4877, 4972,    0, 4967, 4966, 4963, 4962, 1686, 4961,
     4923, 4946, 4919, 4944, 4916, 7311, 4915,    0, 1576, 1583,
     1585, 1625, 1626, 1630, 1632, 1644, 1649, 1079, 4877, 4891,

     4954, 1702, 1777, 1255, 1785, 1846, 1390, 1298, 1692, 1696,
     4953, 1870, 1367, 1894, 1444, 1223, 1859, 1881, 1949, 1290,
     1723, 2030,  975, 1382, 1642, 1742, 1508, 1948, 4952, 1753,
        0, 1933, 4950, 4949, 1940, 4939, 1733, 4946, 1790, 1033,
     4945, 4944, 2072, 2098, 2171, 1485, 2020, 1917, 7311, 1928,
     1660, 1746, 1768, 1808, 1809, 1820, 1855, 1872, 1924, 1936,
     1938, 1942, 1944, 2002, 2007, 2008, 2015, 2016, 2254,    0,
     2022, 2046, 2047,    0, 2048,    0, 2052, 7311, 7311, 2083,
     7311, 7311,    0,    0, 4935, 4889,    0,    0, 4936, 4931,
     4938, 2257, 1154, 2262, 1353, 1455, 1788, 1528, 1590, 2207,

     4937, 2084, 4857, 2085, 2094, 2150, 2151, 2182, 2183, 7311,
     2184, 2188, 2189, 2190, 2223, 4872, 4878, 4873, 2256, 2224,
     4871,    0, 2277, 2285, 4927,    0, 2279,    0,    0, 2309,
     4925, 2322, 1445, 4892, 2237, 1662, 2257, 1692, 1738, 1757,
     2326, 2212, 4870, 4825, 1429, 1348, 4782, 4780, 4790, 4802,
     4775, 4775, 4748, 4857,    0, 4854, 4853, 4852, 4851, 2450,
     2578, 4850, 4849, 7311, 7311, 7311, 7311, 7311, 7311,    0,
        0,    0, 2266,    0,    0,    0, 2291, 2301,    0, 1344,
     2328, 2375, 2368, 2381, 2385, 2389, 2393, 2397, 2402, 2406,
     2410, 2414, 2418, 2422, 2437, 2456, 2460, 2464, 2468, 2472,

     2478,    0, 2497, 2501, 2505,    0, 2509,    0, 4851,    0,
     4794, 1713, 4793, 4766, 4779, 4764, 4771, 4837,    0, 2513,
     1238, 4834, 2705, 4807, 4806, 2731, 4805, 1553, 2506, 4803,
     2532, 1519, 7311,    0,    0,    0, 2303, 2317, 2424, 2480,
     2487,    0,    0, 2517, 2518,    0, 2534, 2536, 2542, 2544,
        0,    0, 2546, 2548,    0, 2550, 2552, 2554, 7311, 4748,
     7311, 7311,    0, 2558, 1650, 2562, 2584, 2588, 2592, 2596,
     2600, 1727, 4717, 4729, 2564, 2604, 2606, 2608, 2615, 2621,
     2622, 2626, 4736, 2627, 4722, 2632, 2633, 2634, 2638, 2644,
     2648,    0, 1818, 2652, 1862, 4779, 1475, 1908, 1927, 2631,

     1956, 2259, 2146, 2662, 2281, 2814, 2276, 4761, 4746, 4746,
     4670, 4691, 4667, 4672, 4677, 4645, 2707, 4643, 4638, 4619,
     4741,    0,    0,    0,    0, 2886, 2828, 2371, 4702, 2378,
     2409, 2799, 4713, 4619, 1831, 4692, 4624, 4616,  889, 4622,
     1709, 4595, 4602, 2863, 2415, 4662, 2424, 2598, 2800, 4669,
     4573, 1848, 4646, 4570, 4562, 1365, 4569, 1867, 4567, 4566,
        0,    0,    0,    0,    0,    0,    0, 2026, 1509, 1635,
        0, 2639, 4663,    0,    0,    0, 2666, 2671, 2675, 2679,
     2683,    0,    0, 2690, 2708,    0, 2712, 2716, 2720, 2724,
        0,    0, 2783, 2818,    0, 2835, 4662, 4660, 2842, 4659,

     4658,    0, 2027, 3013, 3039, 1689, 2344,    0,    0,    0,
        0,    0,    0,    0,    0, 2846, 2850, 2876, 2906, 2911,
     2929, 2933, 2937, 4634, 2726, 2820, 2824, 2880, 2892, 2896,
        0, 2622, 2941, 2900, 4631, 2618, 4622, 4583, 2802, 2794,
     2956, 2844, 4600, 4536, 4485, 4474, 4473, 4483, 1929, 2232,
     2091, 4473, 4473, 4483, 4581,    0,    0, 3122, 3099, 2854,
     4544, 2884, 2905, 3113, 4552, 4455, 1905, 4525, 4431, 4424,
     1651, 4431, 2602, 4432, 4435, 2894, 4503, 2916, 2921, 3155,
     2914, 2924, 2925, 3209, 2914, 4485, 4440, 3282, 3250, 1559,
     2840, 4407, 4402, 4414, 4428, 4402, 4428, 4375, 2916, 4456,

     2974, 2931, 3308, 2924, 2940, 2942, 3309, 2932, 4438, 4390,
     4469, 3379, 1619, 2848, 4357, 4348, 4360, 4374, 4348, 4373,
     4337,    0, 3022, 3028,    0,    0,    0,    0,    0,    0,
        0, 3128, 4447, 4445, 4444, 3145, 3165, 2923, 2997,    0,
     2960, 3091, 3111, 3112, 3104, 4410, 3188, 1879, 2878, 4354,
     4333, 2932, 4344, 4327, 4324, 4322, 4310, 4330, 4411,    0,
        0, 3405, 3382, 3124, 4374, 3117, 3139, 3224, 4383, 4274,
     2297, 4347, 4278, 4267, 1815, 4274, 3043, 4274, 4276, 3125,
     4342, 3175, 3138, 3311, 3132, 3142, 3145, 3398, 3128, 4314,
     4270, 3523, 3464, 1875, 3034, 4237, 4235, 4248, 4262, 4236,

     4259, 4232, 3166, 3192, 3160, 4329, 2172, 3161, 3171, 3313,
     3183, 3204, 3203, 3376, 3221, 3575, 3206, 4311, 4297, 3621,
     3554, 3473, 3579, 4293, 4217, 4234, 4203, 4200, 4204, 4169,
     3294, 4167, 4161, 4161, 3229, 3425, 3237, 4276, 2210, 3265,
     3300, 3314, 3302, 3316, 3303, 3454, 3320, 3682, 3306, 4258,
     4235,    0, 3680, 3493, 3689, 4235, 4156, 4172, 4156, 4144,
     4145, 4111, 3411, 4108, 4097, 4093,    0, 3412,    0, 3389,
     4166, 3460, 3471, 4082, 4081, 4066, 4075, 3519, 3537, 3545,
     4057, 3582, 4177, 4174, 4172, 3817, 3721, 3574,  173, 3461,
     3581, 3827, 1640, 1914, 3617,  508, 2268, 2394, 2469, 2429,

     3591, 2284, 1038, 3626, 2489, 3708, 3571, 3828, 3685, 3699,
     3706, 3864, 3688, 2407, 1054, 2663, 3907, 2421, 3340, 1879,
     2361, 2453,  988, 1452, 2609, 1161, 3582, 3686, 3697, 2976,
     3362, 3429, 3712, 3766, 3744, 3724, 3529, 3782, 3759, 3947,
     3746, 2568, 2551, 4170, 3930, 3992, 3993, 2461, 2487, 2698,
     1770, 2780, 3256, 3157, 3834, 2029, 2725, 2853, 3816, 3598,
     3634, 3635, 3820, 1841, 3257, 3860, 3825, 3951, 3833, 2581,
     4043, 3356, 2615, 2329, 2570, 2597, 3011, 2914, 3622, 3690,
     3773, 1707, 3090, 3027, 3556, 3871, 3277, 3141, 3554, 4162,
     4123, 3731, 3806, 4030, 3834, 4110, 4121, 4043, 4048, 4016,

     3994, 3982, 3978, 3986, 3174, 3344, 3333, 3980, 3968, 3956,
     4050, 7311, 3833, 4013, 3503, 3947, 3935, 3960, 3978, 3991,
     4022, 4039, 4065, 4070, 4074, 4078, 4084, 3951, 4033,    0,
        0, 7311, 4063, 3623, 3845, 3893, 4016, 4112, 3853, 3857,
     3862, 3968, 4125, 3989, 4088, 3331, 3533, 3908, 3881, 3686,
     3889, 3871, 3861, 3865, 3858, 3863,    0,    0, 3907, 3910,
     3813, 3802, 3798, 3806, 4121, 4151, 4155, 3822, 3904, 3922,
        0, 4106, 4143, 4169, 3862, 4174, 4173,    0, 4182, 4173,
     4201, 3779, 3768, 3737, 3735, 4210, 4225, 4229, 3707, 4236,
     3931, 3803, 3720, 3701, 3689, 3933, 4225, 3705, 3714, 3736,

     4230, 3811, 3667, 3643, 4252, 4259, 4265, 4266, 4272, 4276,
     4280, 4310, 4311, 4317, 4321, 4327, 4335, 3649, 3944, 3687,
     4341, 4348, 3599, 3942, 4381, 3686, 3656, 3567, 3524, 3517,
     3506, 4354, 4463, 4408, 4362, 4517, 4434, 4366, 4571, 4623,
     3518, 3492, 3429, 3967, 4632, 4089,    0, 4253, 3497, 3413,
     3381, 3361, 4677, 4382, 4729, 4390, 4783, 4417, 4738, 4471,
     4837, 4472, 4889, 4526, 3327, 3321, 3997, 4358, 3329, 4572,
     4580, 3242, 4648, 4843, 4895, 4652, 4899, 4916, 4665, 4920,
     4924, 3209, 3196, 3185, 3140, 4985, 5029, 5081, 5125, 5177,
     5221, 3094, 3077, 3073, 3050, 5273, 4634, 5301, 4689, 5300,

     4792, 5328, 4796, 5380, 4800, 5408, 4928, 3055, 2999, 2933,
     2918, 4678, 4754, 4758, 2875, 2847, 2789, 2802, 2787, 2754,
     2701, 2607, 2623, 2622, 2564, 2539, 2485, 2252, 2134, 1968,
     1911, 1849, 1441, 1445, 7311, 5461, 5472, 5483, 5494, 5505,
     5516, 5527, 5538, 5549, 5560, 5571, 5575, 5586, 5597, 5608,
     5619, 5630, 5641, 5652, 5663, 5674, 5685, 5696, 5707, 5711,
     5722, 5733, 5744, 5755, 5760, 5761, 5766, 5777, 5788, 5799,
     5810, 5821, 5832, 5843, 5854, 5865, 5876, 5887, 5898, 5909,
     1399, 5920, 5931, 5942, 5953, 5964, 5975, 5986, 5997, 1210,
     5999, 6010, 6021, 6032, 6043, 6054, 6065, 6076, 6087, 6098,

     6109, 6120, 6131, 6142, 6153, 6164, 6175, 6186, 6197, 6208,
     6219, 1080, 6221, 6232, 6243, 6254, 6265, 6276, 6287, 6298,
     6309, 6320, 6331, 6342, 6353, 6364, 6375, 6386, 6397, 6408,
     6419, 6430, 6441, 6452, 6463, 6474, 6485, 6496, 6507, 6518,
     6529, 6540, 6551, 6562, 6573, 6584, 6595, 6606, 6617, 6628,
     6639, 6650, 6661, 6672, 6683, 6694, 6705, 6716, 6727, 6738,
     6749, 6760, 6771, 6782, 6793, 6804, 6815, 6826, 6837, 6848,
     6859, 6870, 6881, 6892, 6903, 6914, 6925, 6936, 6947, 6958,
     6969, 6980, 6991, 7002, 7013, 7024, 7035, 7040, 7050, 7061,
     7072, 7083, 7094, 7105, 7116, 7127, 7138, 7149, 7160, 7171,

      973, 7182, 7193, 7204, 7215, 7226, 7237, 7244, 7254, 7259,
     7263,  517,  511, 7273, 7284, 7295, 7300,  198
    } ;

static const flex_int16_t yy_def[1619] =
    {   0,
     1436, 1436, 1437, 1437, 1435,    5,    5,    5, 1438, 1438,
     1435,   11, 1435,   13, 1439, 1439, 1440, 1440, 1435,   19,
     1435,   21, 1435,   23, 1441, 1441, 1442, 1442, 1443, 1443,
     1436, 1436, 1444, 1444, 1445, 1445, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1446, 1435, 1435, 1435, 1435, 1435, 1447,
     1435, 1435, 1446, 1435,   51, 1435, 1435, 1435, 1448, 1435,
     1435, 1435, 1449, 1435, 1435, 1435, 1450, 1435, 1435, 1435,
     1435, 1435, 1451, 1435, 1435, 1452, 1435, 1435, 1453, 1435,
     1435, 1454, 1435, 1446, 1435, 1435, 1435, 1435, 1435, 1455,
     1435, 1455, 1455, 1435, 1435, 1435, 1456, 1457, 1435, 1457,

     1435, 1435, 1435, 1435, 1435, 1458, 1458, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1459, 1435, 1435, 1435, 1435,
     1435,   51, 1446, 1435, 1435, 1435, 1435, 1460, 1435, 1435,
     1461, 1435, 1435, 1462, 1463, 1435, 1435, 1435, 1464, 1435,
     1435, 1435, 1465, 1466, 1467, 1435, 1435, 1435, 1435, 1435,
     1435, 1459, 1435,  121,   51, 1446, 1462, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1468, 1435, 1435, 1435, 1435, 1469, 1435, 1435, 1435, 1435,
     1435, 1470, 1435, 1471, 1435, 1472, 1435, 1473, 1435, 1435,
     1435, 1435, 1435, 1474, 1435, 1435, 1435, 1435, 1446, 1435,

     1435, 1435, 1435, 1435, 1475, 1435, 1435, 1435, 1435, 1475,
     1435, 1435, 1476, 1477, 1476, 1477, 1476, 1478, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1479, 1479, 1479,
     1479, 1479, 1479, 1479, 1479, 1479, 1479, 1435, 1435, 1435,
     1480, 1435, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1481, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1482, 1435, 1483, 1435, 1435, 1484, 1435, 1485, 1485,
     1485, 1485, 1485, 1485, 1485, 1485, 1435, 1486, 1487, 1435,
     1488, 1489, 1435, 1490, 1435, 1435, 1491, 1435, 1492, 1435,

     1435, 1435, 1493, 1435, 1480, 1435, 1480, 1480, 1480, 1480,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1485, 1485, 1485,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1494, 1494, 1495, 1494, 1494, 1494, 1494, 1435,
     1435, 1496, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1496, 1497, 1498, 1498, 1499, 1499, 1499, 1500,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1501, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1435, 1435, 1435, 1435,

     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1503, 1480, 1480, 1480, 1504, 1505, 1480, 1480, 1480, 1480,
     1480, 1480,  422,  422,  422, 1480, 1480, 1480, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1506,
     1435, 1435, 1435, 1507, 1435, 1508, 1435, 1435, 1435, 1435,
     1435, 1435, 1509, 1510, 1511, 1435, 1512, 1513, 1514, 1515,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1516,

     1480, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1517, 1517, 1517, 1517, 1517, 1517, 1517, 1518, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1518, 1519, 1520, 1520, 1521, 1521, 1521,
     1435, 1522, 1522, 1435, 1435, 1435, 1435, 1435, 1435, 1523,
     1524, 1525, 1526, 1527, 1528, 1529, 1435, 1480, 1530, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,

     1480, 1531, 1480, 1480, 1480, 1532, 1480, 1533, 1480, 1534,
     1534, 1534, 1534, 1534, 1534, 1534, 1534, 1480, 1535, 1480,
     1536, 1480, 1480, 1480, 1480,  623, 1480, 1537, 1480, 1480,
     1480, 1538, 1435, 1539, 1540, 1541, 1435, 1435, 1435, 1435,
     1435, 1542, 1543, 1435, 1435, 1544, 1435, 1435, 1435, 1435,
     1545, 1546, 1435, 1435, 1547, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1548, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1549, 1549, 1549, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1550,
     1550, 1551, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1551, 1552, 1553, 1554, 1555, 1554, 1555, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1556, 1557, 1558, 1559, 1560, 1561, 1562, 1480, 1480, 1480,
     1563, 1480, 1480, 1564, 1565, 1566, 1480, 1480, 1480, 1480,
     1480, 1567, 1568, 1480, 1480, 1569, 1480, 1480, 1480, 1480,
     1570, 1571, 1480, 1480, 1572, 1480, 1480, 1480, 1480, 1480,

     1480, 1573, 1574, 1480,  804, 1575, 1576, 1577, 1578, 1579,
     1580, 1581, 1582, 1583, 1584, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1435, 1435, 1435, 1435, 1435, 1435,
     1585, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1585, 1586, 1587, 1587, 1587, 1587,
     1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587,
     1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587,
     1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587,
     1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1588, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1589, 1480, 1480, 1590, 1591, 1592, 1593, 1594, 1595,
     1596, 1480, 1480, 1480, 1480, 1597, 1480, 1435, 1435, 1598,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1598, 1599,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1601, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1602, 1597, 1603, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1604, 1605, 1606,
     1435, 1435, 1603, 1607, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1608, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1601, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1608, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1171, 1435, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1609, 1435, 1435, 1435, 1435, 1435, 1435, 1605, 1604, 1604,
     1604, 1605, 1605, 1605, 1606, 1606, 1606, 1435, 1435, 1607,
     1607, 1435, 1435, 1435, 1435, 1435, 1610, 1435, 1435, 1435,
     1435, 1435, 1435, 1611, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1609, 1609, 1435, 1435,
     1435, 1435, 1435, 1435, 1604, 1605, 1606, 1435, 1435, 1435,
     1612, 1435, 1435, 1435, 1435, 1435, 1435, 1613, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1614, 1615, 1616, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1610, 1435, 1435, 1435,

     1611, 1435, 1435, 1435, 1615, 1614, 1614, 1614, 1614, 1615,
     1615, 1615, 1615, 1616, 1616, 1616, 1616, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1617, 1435, 1435, 1435, 1435,
     1435, 1614, 1614, 1614, 1615, 1615, 1615, 1616, 1616, 1616,
     1435, 1435, 1435, 1435, 1435, 1435, 1618, 1435, 1435, 1435,
     1435, 1435, 1614, 1614, 1614, 1614, 1615, 1615, 1615, 1615,
     1616, 1616, 1616, 1616, 1435, 1435, 1435, 1617, 1435, 1435,
     1435, 1435, 1333, 1614, 1614, 1336, 1615, 1615, 1339, 1616,
     1616, 1435, 1435, 1435, 1435, 1614, 1333, 1615, 1336, 1616,
     1339, 1435, 1435, 1435, 1435, 1614, 1614, 1353, 1614, 1615,

     1615, 1357, 1615, 1616, 1616, 1361, 1616, 1435, 1435, 1435,
     1435, 1387, 1389, 1391, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435,    0, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435
    } ;

static const flex_int16_t yy_nxt[7441] =
    {   0,
     1435, 1435,   40,   41,   40,   41,   42,   43,   44,   45,
       43,   42,   42,   42,   42,   42,   46,   47,   42,   42,
       42,   48,   49,   46,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   42,
       51,   42,   42,   42,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,

       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   52,   53,   54,   52,   52,
       53,   54,   52,   69,   57,   57,   83,   84,   85,   83,
       42,   91,   92,   93,   42,   83,   84,   85,   83, 1435,
       86,   87,   58,   58,   91,   92,   93,   95,   95,   86,
       87,   99,  100,  409,   96,   96,   99,  100,   70, 1232,
      126,   97,   97,  126,   71,  547,   72,  548,   55,   59,
       59,  162,   55,  457,  162,  103,  104,  105,  103,   88,

      157,   89,  458,  177,  106,  158,  177, 1368,   88,   70,
       89,  107,  900,  173,  174,   71,  175,   72,  201,  202,
       60,   60,   61,   61,   61,   62,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   61,   61,   61,   61,   61,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,

       63,   63,   63,   63,   63,   63,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   64,   64,   64,   65,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   66,   64,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,

       67,   67,   67,   67,   64,   64,   64,   64,   64,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       69,  109,  110,  110,  109,  389,  480,  480,  115,  116,
      117,  115,  389,  305,  491,  111,  112,  118,  119,  200,

      200,  200,  200,  120,  121,  163,  164,  165,  166,  167,
      168,  169,  219,  220, 1232,   70,  206,  207,  208,  206,
     1301,   71,  470,   72,  226,  227, 1297,  221,  103,  224,
      225,  103,  106,  471,  113,  103,  104,  105,  103,  107,
      126,  122,  126,  126,  106,  126,   70,  276,  510,  510,
      276,  107,   71,  913,   72,   74,   74,   74,   75,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,

       76,   76,   76,   76,   76,   76,   76,   76,   74,   74,
       74,   74,   74,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   77,   77,   77,   78,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,

       77,   77,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   77,   77,   77,
       77,   77,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,

       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   80,   80,   80,   81,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   80,   80,   80,   80,
       80,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   80,   80,   80,

       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,  110,  123,  110,  110,  276,  271,  288,  276,
      533,  272,  130,  149,  273,  130,  149,  112,  130,  239,
      151,  152,  153,  151,  238,  189,  130,  111,  189,  118,
      119,  193,  194,  195,  193,  290,  154, 1435,  290,  190,
      191,  533, 1197,  302,  291,  214,  302,  892,  215,  893,
      289, 1435,  303, 1435, 1232,  112,  129,  129,  130,  129,

      131,  131,  132,  129,  133,  134,  150,  135,  150,  130,
      136,  137,  130,  155,  327,  196, 1435,  327,  192,  322,
      323,  324,  325,  130,  197,  130,  198,  216,  109,  110,
      110,  109,  138,  130,  328, 1435,  217,  328,  304,  305,
      306,  304,  111,  112, 1232,  407,  329,  139,  140,  329,
      600,  141,  129,  138,  129,  129,  142,  143,  216,  138,
     1232,  330,  144,  138,  330,  145,  146,  129,  408,  129,
      147,  130,  129,  138,  148,  138,  229,  129,  129,  130,
     1063,  113,  130,  230,  110,  110,  110,  110,  231,  295,
      130,  150,  232,  233,  234,  331,  235,  458,  331,  112,

      240,  241,  242,  240,  244,  116,  245,  244,  507,  332,
      622,  236,  332,  246,  247,  112,  219,  220,  333,  248,
      249,  333,  550,  551,  237,  110,  116,  110,  110,  219,
      220,  221,  115,  116,  117,  115,  177,  112,  921,  177,
      112,  118,  119,  177,  221, 1051,  177,  120,  121,  577,
      577,  395,  149,  113,  395,  149, 1435,  250,  278,  278,
      278,  278,  278,  278,  278,  278,  111, 1232,  342,  280,
      271,  342,  157,  281,  272,  282,  283,  158,  112,  251,
      252,  284,  251,  191,  397,  122,  285,  397,  459,  286,
      326,  459,  300,  326,  300,  253,  301,  301,  301,  301,

      301,  301,  301,  301,  301,  150,  254,  535,  322,  323,
      324,  325,  255,  256, 1435,  536,  257,  460,  258,  487,
      259,  192,  260,  261,  262, 1435,  263,  466,  264,  461,
      466,  664,  124,  200,  200,  200,  200,  265,  535,  266,
      485,  267,  311,  312,  268,  313,  536,  314,  401,  269,
      307,  152,  308,  307,  270,  315,  316, 1435,  189,  246,
      247,  189,  317,  472,  472,  473,  309,  151,  152,  153,
      151,  409,  190,  191,  280, 1066,  118,  119,  318,  350,
      282,  319,  203,  154,  589,  203,  320,  340,  340,  340,
      340,  285, 1435,  590,  286,  344,  345,  346,  344,  350,

     1435,  398,  341,  310,  399,  193,  194,  195,  193,  400,
      350,  192,  200,  200,  200,  200,  351,  351,  351,  351,
      155,  206,  353,  354,  206,  206,  207,  208,  206,  388,
      350,  378,  388,  251,  252,  192,  251,  226,  227,  347,
      355,  356,  357,  355,  388,  106, 1435,  388,  348,  196,
      349,  381,  107,  382,  397, 1435,  772,  397,  197,  379,
      198,  597,  383,  389,  384,  276,  385,  358,  276, 1435,
      379,  390,  389,  386,  359,  360,  379,  389,  361,  362,
      393,  363,  580,  393, 1435,  364,  450,  390,  389,  450,
      379,  393, 1435,  391,  393,  451,  579,  393,  462,  387,

      393,  379,  451,  430, 1435,  365,  430,  379,  467,  584,
      290,  393,  463,  290,  393,  240,  241,  242,  240,  291,
      451,  511,  393,  512,  511,  393,  512,  667,  393,  451,
      112,  393,  402,  241,  403,  402,  110,  241,  110,  110,
      405,  110,  402,  405,  601,  302, 1435,  404,  302,  450,
      513,  112,  450,  513,  303,  404,  492, 1435, 1232,  366,
      367,  368,  369,  915,  370,  916,  371,  372,  113,  402,
      116,  402,  402,  712,  713,  514,  453,  451,  514,  304,
      305,  306,  304,  464,  404,  404,  588, 1435,  451,  112,
      454,  628,  453,  406,  464,  710,  464,  693,  455,  450,

      464,  515,  450,  326,  515,  327,  326,  464,  327,  328,
     1435, 1435,  328,  464,  464,  329,  330,  331,  329,  330,
      331,  490,  404,  410,  252,  464,  410,  464,  693,  401,
     1435,  464,  150,  451,  332,  475,  668,  332,  464,  411,
      333, 1281,  451,  333,  464,  340,  340,  340,  340,  711,
      412,  340,  340,  340,  340,  489,  413,  414,  342,  401,
      415,  342,  416, 1434,  417,  695,  418,  419,  420, 1064,
      421,  606,  422,  191,  503,  523,  407,  388,  523,  504,
      388,  423,  695,  424,  388,  425,  571,  388,  426,  571,
      524,  923, 1435,  427,  344,  345,  346,  344,  428,  129,

      429,  430,  429,  431,  431,  432,  433,  434,  435,  670,
      436,  192,  526,  437,  438,  430,  301,  301,  301,  301,
      301,  301,  301,  301,  301, 1024,  572,  573,  525,  572,
      573,  574,  526,  575,  574,  439,  575, 1435,  347,  351,
      351,  351,  351,  526, 1435,  576, 1232,  348,  576,  349,
      397,  440, 1435,  397,  441,  429,  439,  429,  429,  442,
      443,  450,  439,  526,  450,  444,  439,  909,  445,  446,
      429,  671,  429,  447,  430,  429,  439,  448,  439, 1025,
      429,  429,  430,  410,  252, 1056,  410,  560,  561,  560,
      560,  489,  559,  581, 1435,  935,  581,  410,  252,  411,

      410,  923,  698,  402,  110,  402,  402,  537,  602,  493,
      494,  538,  495, 1232,  496,  539,  413,  414,  404,  603,
      415,  540,  497,  498,  417, 1435,  418,  419,  420,  499,
      421,  817,  422,  698,  581, 1435,  407,  581,  541, 1057,
      704,  423,  538,  424, 1435,  425,  539,  634,  426,  996,
      634,  997,  540,  427,  430, 1435,  404,  430,  428,  129,
      429,  430,  429,  431,  431,  432,  433,  434,  500,  450,
      436,  704,  450,  501,  438,  430, 1232,  705,  402,  241,
      402,  402,  598,  799,  799,  598,  405,  110,  402,  405,
     1435,  620, 1435,  404,  620,  439,  706,  824,  824,  542,

      621,  404,  895,  896,  604,  604,  605,  492,  705,  635,
      636,  440,  635,  636,  441,  429,  439,  429,  429,  442,
      443,  637,  439, 1254,  637,  444,  439,  706,  445,  446,
      429,  404,  429,  447,  430,  429,  439,  448,  439,  406,
      429,  429,  430,  355,  530,  531,  355, 1232, 1435,  832,
      430, 1239,  355,  530,  531,  355,  638,  578,  590,  638,
      591, 1435,  409,  591,  430,  532,  356,  357,  532,  669,
      358,  582, 1435,  639,  582, 1201,  639,  359,  360,  358,
      832,  361,  362, 1435,  363, 1232,  359,  360,  364,  592,
      361,  362,  358,  363,  888,  582, 1435,  364,  582,  359,

      360,  593,  836,  361,  362,  583,  363,  889,  365,  583,
      364,  911,  594, 1120,  583, 1121,  583,  365,  631, 1435,
     1232,  631,  585,  430,  912,  459,  595,  632,  459,  450,
      365,  430,  450,  836,  633, 1435,  586,  640,  585,  641,
      640, 1148,  641,  642,  587,  643,  642, 1433,  643,  704,
     1435, 1435,  609,  609,  609,  609,  609,  609,  609,  609,
      918,  919,  366,  367,  368,  369,  704,  370,  992,  371,
      372,  366,  367,  368,  369, 1072,  370,  583,  371,  372,
      704,  993,  596,  596,  366,  367,  368,  369,  583,  370,
     1073,  371,  372,  596,  596, 1149,  704,  704,  611,  596,

      596, 1060,  612,  644,  613,  614,  644, 1073,  645,  646,
      615,  645,  646,  596,  596,  616,  647,  648,  617,  647,
      648,  607, 1435,  652,  596,  596,  652,  704, 1435,  485,
      596,  596, 1435,  910,  629, 1232,  629,  934,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  653,  654,  656,
      653,  654,  656,  657,  951,  952,  657,  599,  599,  599,
      599,  599,  599,  599,  599,  599,  599,  599,  599,  599,
      599,  599,  599,  599,  599,  599,  599,  599,  599,  599,
      599,  599,  599,  623,  658,  675,  677,  658,  675,  677,
     1432,  624,  624,  624,  624,  678,  923,  923,  678,  624,

      624,  624,  624,  624,  624,  624,  624,  624,  624,  624,
      624,  624,  624,  624,  624,  624,  624,  624,  624,  624,
      624,  624,  624,  624,  624,  625,  625,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,
      625,  679,  680, 1208,  679,  680,  625,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,
      625,  625,  626,  681,  682,  511,  681,  682,  511,  512,
      513,  514,  512,  513,  514,  839,  954,  955,  627,  627,

      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  515,  688,  839,  515,  688,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  649, 1431,  686,  649, 1435,
      686,  430, 1129,  582, 1435,  611,  582,  573,  695,  672,
      573,  613,  673,  650, 1232,  430,  687,  674,  523, 1129,
      527,  523,  616,  527,  699,  617,  690,  340,  690,  690,
     1232,  696,  658,  524,  838,  658,  700,  583,  707,  695,

     1037,  691,  538, 1435,  637,  701,  583,  637,  839,  702,
      532,  530,  531,  532,  707,  699,  704, 1037,  638,  538,
      650,  638,  844,  532,  530,  531,  532,  700,  842,  581,
     1435,  525,  581,  525,  430, 1232,  701,  358,  665,  839,
      703,  953,  430,  666,  359,  360,  490,  704,  361,  362,
      358,  363, 1430,  699,  936,  364,  697,  359,  360,  842,
     1116,  361,  362,  768,  363,  700,  769, 1232,  364,  582,
     1435,  770,  582, 1117,  701,  365,  582, 1435,  703,  582,
      753,  773,  774, 1435,  699,  774,  582, 1435,  365,  582,
      775, 1435,  920,  775,  776, 1435,  700,  776,  777, 1435,

     1232,  777,  876,  778, 1435,  701,  778,  779, 1435,  703,
      779,  591, 1435, 1232,  591,  780, 1435,  878,  780,  781,
     1435, 1245,  781,  782, 1435,  639,  782, 1232,  639,  366,
      367,  368,  369,  876,  370, 1232,  371,  372,  783, 1435,
      879,  783,  366,  367,  368,  369,  899,  370,  878,  371,
      372,  726,  561,  726,  726, 1050,  727,  784, 1435, 1232,
      784,  785, 1435,  901,  785,  786, 1435, 1232,  786,  787,
     1435,  879,  787,  788, 1435, 1232,  788,  899,  728,  789,
     1435,  640,  789, 1061,  640,  729,  730, 1056,  641,  731,
      732,  641,  733, 1232,  901, 1232,  734,  790,  792, 1435,

     1046,  792,  793, 1435,  735,  793,  794, 1435, 1435,  794,
      796, 1435,  914,  796,  620, 1435,  736,  620,  644,  645,
     1036,  644,  645,  621,  630,  630,  630,  630,  630,  630,
      630,  630,  630,  631, 1435,  647,  631,  648,  647,  917,
      648, 1057,  632,  649,  790,  649,  649,  653,  649,  654,
      653,  656,  654,  657,  656,  658,  657, 1232,  658,  816,
     1435, 1062,  816,  818, 1435,  675,  818,  915,  675,  916,
      737,  738,  739,  740, 1232,  741, 1232,  742,  743,  561,
      561,  561,  561, 1429,  744,  819, 1435, 1232,  819,  820,
     1435, 1046,  820,  821, 1435, 1196,  821,  822, 1435, 1056,

      822,  823, 1435, 1232,  823,  825,  745,  677,  825,  678,
      677, 1242,  678,  746,  747, 1232,  679,  748,  749,  679,
      750, 1232,  680,  681,  751,  680,  681,  682,  827,  902,
      682,  827,  752,  686,  829,  688,  686,  829,  688,  830,
      924, 1435,  830,  924,  753,  690,  340,  690,  690,  690,
      340,  690,  690,  833,  834,  835,  833,  941,  704,  704,
      902, 1428,  704,  833,  834,  835,  833,  777, 1435, 1232,
      777,  704,  778, 1435, 1052,  778,  779, 1435, 1244,  779,
      780, 1435, 1245,  780,  781, 1435, 1427,  781,  941,  704,
      704,  784, 1435,  704,  784,  999, 1000, 1065,  754,  755,

      756,  757,  704,  758, 1232,  759,  760, 1435,  849,  785,
     1435,  849,  785,  787, 1435, 1426,  787,  788, 1435, 1246,
      788,  789, 1435, 1425,  789,  789, 1435,  825,  789, 1424,
      825, 1232,  804,  804,  804,  804,  804,  804,  804,  804,
      804,  804,  804,  804,  804,  804,  804,  804,  804,  804,
      804,  804,  804,  804,  804,  804,  804,  804,  805,  805,
      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,
      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,
      805,  805,  805,  805,  793, 1435, 1232,  793, 1200,  805,
      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,

      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,
      805,  805,  805,  805,  805,  833,  834,  835,  833,  794,
     1435,  938,  794, 1423,  938,  827,  880,  903,  827,  704,
      881,  904,  850,  851,  882,  905,  796, 1435,  944,  796,
      883,  906,  840,  932, 1435,  841,  932,  816, 1435, 1422,
      816,  937, 1435, 1209,  937,  704,  728,  884,  907, 1232,
      704,  881,  904,  729,  730,  882,  905,  731,  732,  944,
      733,  883,  906,  840,  734,  945,  841,  818, 1435, 1202,
      818,  939,  735, 1281,  939,  980,  704,  858,  561,  858,
      858,  745,  859,  829,  736, 1421,  829,  830,  746,  747,

      830,  942,  748,  749,  942,  750,  945,  819, 1435,  751,
      819, 1420,  820, 1435,  860,  820,  980,  752,  885,  908,
     1232,  861,  862,  982,  938,  863,  864,  938,  865,  753,
      821, 1435,  866,  821,  822, 1435,  983,  822,  823, 1435,
      867,  823,  833,  834,  835,  833, 1003, 1005,  737,  738,
      739,  740,  868,  741,  982,  742,  743,  833,  834,  835,
      833, 1008, 1014, 1015, 1016, 1026, 1027,  983, 1035, 1419,
     1006, 1040, 1046, 1058, 1059, 1074, 1075, 1003, 1005, 1047,
     1210, 1048, 1232,  754,  755,  756,  757, 1190,  758, 1070,
      759,  760, 1008, 1014, 1015, 1016,  704, 1418,  939, 1035,

     1017,  939, 1040, 1046,  985, 1037,  869,  870,  871,  872,
     1047,  873, 1048,  874,  875, 1435, 1017, 1232, 1049, 1417,
     1070,  985,  904,  932, 1435, 1248,  932,  704, 1038,  924,
     1435, 1416,  924, 1232, 1049, 1007, 1037, 1077,  955,  904,
      624,  624,  624,  624,  624,  624,  624,  624,  624,  624,
      624,  624,  624,  624,  624,  624,  624,  624,  624,  624,
      624,  624,  624,  624,  624,  624,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  942, 1039, 1415,  942, 1232,  627,  627,  627,

      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  962,  561,  962,  962,  964,  963,  932,
     1435, 1256,  932, 1247,  965,  966, 1123, 1124,  967,  968,
      984,  969,  695,  704,  985,  970,  401,  815,  986,  401,
      964, 1073,  704,  971,  987, 1104, 1106,  965,  966, 1150,
     1151,  967,  968, 1232,  969,  972,  937, 1435,  970,  937,
     1107,  988, 1411,  695,  704,  985,  971, 1127, 1132,  986,
     1138, 1139, 1009,  704, 1140,  987, 1104, 1106,  972,  833,
      834,  835,  833, 1160, 1010, 1410, 1160, 1159, 1161, 1409,

     1163, 1107, 1138, 1011, 1237, 1255, 1129, 1012, 1127, 1132,
     1138, 1138, 1139, 1009, 1141, 1140, 1408, 1238, 1109,  973,
      974,  975,  976, 1138,  977, 1010,  978,  979, 1159, 1130,
     1141, 1163,  989, 1138, 1011, 1109, 1009, 1129, 1013, 1165,
     1395, 1138,  973,  974,  975,  976, 1162,  977, 1010,  978,
      979, 1108, 1166, 1166, 1138, 1109, 1138, 1011, 1169, 1110,
     1185, 1013, 1232, 1232, 1022, 1111, 1022, 1009, 1023, 1023,
     1023, 1023, 1023, 1023, 1023, 1023, 1023, 1189, 1236, 1010,
     1204, 1236, 1112, 1166, 1166, 1394, 1109, 1138, 1011, 1169,
     1110, 1185, 1013, 1020, 1131, 1179, 1111, 1393, 1179, 1249,

     1250, 1021, 1021, 1021, 1021, 1036, 1046, 1392, 1189, 1021,
     1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021,
     1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021,
     1021, 1021, 1021, 1021, 1021, 1041, 1041, 1046, 1133, 1046,
     1138, 1046, 1046, 1113, 1138, 1046, 1232, 1042, 1042, 1203,
     1134, 1191, 1192, 1138, 1046, 1046, 1043, 1043, 1195, 1135,
     1044, 1045, 1232, 1136, 1385, 1192, 1041, 1041, 1232, 1133,
     1046, 1138, 1046, 1046, 1046, 1138, 1046, 1160, 1042, 1042,
     1160, 1134, 1161, 1192, 1138, 1046, 1046, 1043, 1043, 1195,
     1135, 1045, 1045, 1054, 1137, 1054, 1192, 1055, 1055, 1055,

     1055, 1055, 1055, 1055, 1055, 1055, 1086,  561, 1086, 1086,
     1088, 1087, 1205,  401,  815, 1205,  401, 1089, 1090, 1180,
     1181, 1091, 1092, 1213, 1093, 1133, 1186, 1280, 1094, 1186,
     1162, 1187, 1243, 1088, 1200, 1232, 1095, 1134, 1252, 1253,
     1089, 1090, 1281, 1383, 1091, 1092, 1135, 1093, 1096, 1382,
     1137, 1094, 1037, 1251, 1213, 1186, 1133, 1372, 1186, 1095,
     1187,  833,  834,  835,  833, 1058, 1059, 1232, 1134, 1037,
     1046, 1096,  833,  834,  835,  833, 1371, 1135, 1146, 1188,
     1146, 1137, 1147, 1147, 1147, 1147, 1147, 1147, 1147, 1147,
     1147, 1147, 1147, 1147, 1147, 1147, 1147, 1147, 1147, 1147,

      901, 1046, 1097, 1098, 1099, 1100, 1370, 1101, 1188, 1102,
     1103, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055,
     1220,  834, 1221, 1220, 1369, 1097, 1098, 1099, 1100, 1366,
     1101,  901, 1102, 1103, 1144, 1232, 1206, 1207, 1223,  834,
     1224, 1223, 1145, 1145, 1145, 1145, 1226,  834, 1227, 1226,
     1145, 1145, 1145, 1145, 1145, 1145, 1145, 1145, 1145, 1145,
     1145, 1145, 1145, 1145, 1145, 1145, 1145, 1145, 1145, 1145,
     1145, 1145, 1145, 1145, 1145, 1145, 1160, 1232, 1192, 1160,
     1232, 1161, 1088,  833,  834,  835,  833, 1232, 1232, 1089,
     1090, 1235, 1365, 1091, 1092, 1046, 1093, 1232, 1261, 1186,

     1094, 1262, 1186, 1167, 1234,  899, 1168, 1088, 1172, 1192,
     1288, 1040,  902, 1185, 1089, 1090, 1138, 1046, 1091, 1092,
     1096, 1093, 1235, 1232, 1236, 1094, 1046, 1236, 1232, 1162,
     1282, 1283, 1232, 1173, 1167, 1236,  899, 1168, 1236, 1352,
     1232, 1232, 1040,  902, 1185, 1096, 1351, 1138, 1171, 1171,
     1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171,
     1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171,
     1171, 1171, 1171, 1171, 1097, 1098, 1099, 1100, 1035, 1101,
      911, 1102, 1103, 1186,  918,  919, 1186, 1186, 1187, 1350,
     1186, 1232, 1234,  912, 1232, 1349, 1232, 1347, 1237, 1097,

     1098, 1099, 1100, 1232, 1101, 1232, 1102, 1103,  745, 1035,
     1193, 1238, 1232, 1194, 1232,  746,  747,  745, 1232,  748,
      749, 1343,  750, 1046,  746,  747,  751, 1232,  748,  749,
     1232,  750,  704, 1046, 1198,  751, 1188, 1189, 1047, 1037,
     1188, 1193, 1341, 1199, 1194, 1048,  753, 1249, 1250,  745,
     1232, 1046, 1232, 1331, 1046,  753,  746,  747, 1046, 1191,
      748,  749, 1038,  750, 1046, 1232, 1330,  751, 1189, 1047,
     1037, 1327, 1232, 1192, 1049,  752, 1048, 1326,  904, 1232,
     1200, 1325, 1046, 1186, 1046, 1323, 1186,  753, 1234, 1046,
     1049, 1285, 1253, 1046, 1046,  904, 1322, 1046, 1195, 1251,

      754,  755,  756,  757, 1192,  758, 1046,  759,  760,  754,
      755,  756,  757, 1321,  758, 1046,  759,  760,  561,  561,
      561,  561, 1232, 1233, 1046, 1046, 1232, 1039, 1046, 1195,
     1320, 1232, 1318, 1232, 1232, 1205, 1188, 1046, 1205, 1232,
     1232,  754,  755,  756,  757,  745,  758, 1305,  759,  760,
     1240, 1235,  746,  747,  903, 1041,  748,  749,  904,  750,
     1304, 1046,  905,  751, 1241, 1241, 1232, 1042,  906, 1240,
     1232,  752, 1186, 1259, 1270, 1186, 1043, 1187, 1252, 1253,
     1044, 1240, 1235,  753, 1037,  907, 1041, 1046, 1046,  904,
     1303, 1041, 1046,  905, 1236, 1241, 1241, 1236, 1042,  906,

     1240, 1302, 1300, 1042, 1259, 1270, 1328, 1043, 1269, 1329,
     1046, 1045, 1043, 1232, 1080, 1037, 1045,  704, 1046, 1046,
     1295, 1054, 1041, 1054, 1294, 1055, 1055, 1055, 1055, 1055,
     1055, 1055, 1055, 1055, 1042, 1293, 1232,  754,  755,  756,
      757, 1046,  758, 1043,  759,  760,  908, 1045, 1186, 1292,
     1290, 1186, 1186, 1234, 1291, 1186, 1296, 1234,  745, 1206,
     1207, 1223,  834, 1224, 1223,  746,  747, 1290, 1289,  748,
      749, 1319,  750, 1324, 1288, 1193,  751,  704, 1194, 1265,
      834, 1221, 1265, 1287, 1198, 1291, 1286, 1296, 1046, 1344,
     1251, 1046, 1265,  834, 1221, 1265,  753, 1284, 1232, 1232,

     1278, 1188, 1319, 1275, 1324, 1188, 1193, 1367,  704, 1194,
     1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 1046,
     1344,  745, 1046, 1265,  834, 1221, 1265, 1271,  746,  747,
     1046, 1186,  748,  749, 1186,  750, 1187, 1269, 1367,  751,
     1266,  834, 1224, 1266, 1268, 1264, 1263, 1199, 1260, 1232,
      754,  755,  756,  757, 1435,  758, 1258,  759,  760,  753,
     1256, 1046, 1435, 1435, 1435, 1435, 1266,  834, 1224, 1266,
     1046, 1266,  834, 1224, 1266, 1267,  834, 1227, 1267, 1267,
      834, 1227, 1267, 1255, 1188, 1267,  834, 1227, 1267, 1186,
     1186,  745, 1186, 1186, 1187, 1187, 1254, 1248,  746,  747,

     1247, 1046,  748,  749, 1246,  750, 1245, 1186, 1245,  751,
     1186, 1244, 1187,  754,  755,  756,  757,  752,  758, 1243,
      759,  760, 1265,  834, 1221, 1265, 1273, 1435, 1273,  753,
     1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1276,
     1242, 1276, 1188, 1277, 1277, 1277, 1277, 1277, 1277, 1277,
     1277, 1277, 1266,  834, 1224, 1266, 1267,  834, 1227, 1267,
     1298, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
     1186, 1036, 1239, 1186, 1186, 1187, 1232, 1186, 1232, 1187,
     1231, 1229, 1228,  754,  755,  756,  757, 1218,  758, 1217,
      759,  760, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,

     1277,  745, 1186, 1216, 1215, 1186, 1214, 1187,  746,  747,
      745, 1307,  748,  749, 1307,  750, 1308,  746,  747,  751,
     1210,  748,  749, 1299,  750, 1209, 1311, 1188,  751, 1311,
     1315, 1312, 1208, 1315, 1204, 1316, 1435, 1186, 1203,  753,
     1186, 1435, 1187, 1202, 1435, 1435, 1435, 1435,  753, 1435,
     1435, 1435, 1435, 1311, 1186, 1188, 1311, 1186, 1312, 1187,
     1332, 1201, 1200, 1332, 1309, 1308, 1332, 1332, 1056, 1332,
     1332, 1308, 1308, 1332, 1046, 1046, 1332, 1335, 1308, 1313,
     1335, 1335, 1312, 1317, 1335, 1196, 1312, 1190, 1184, 1183,
     1188, 1182, 1178,  754,  755,  756,  757, 1177,  758, 1176,

      759,  760,  754,  755,  756,  757, 1313,  758, 1175,  759,
      760, 1335, 1335, 1309, 1335, 1335, 1312, 1312, 1338, 1309,
     1309, 1338, 1338, 1316, 1174, 1338, 1309, 1316, 1338, 1148,
     1313, 1338, 1138, 1316, 1313, 1333, 1338, 1138, 1170, 1338,
     1164, 1316,  833,  834,  835,  833, 1158, 1157, 1334,  833,
      834,  835,  833, 1156, 1155, 1332, 1154, 1153, 1332, 1152,
     1308, 1143, 1142, 1335, 1313, 1313, 1335, 1338, 1312, 1435,
     1338, 1317, 1316, 1128, 1336, 1317, 1126, 1435, 1435, 1435,
     1435, 1317, 1125, 1332, 1122, 1119, 1332, 1337, 1308, 1317,
     1096, 1332, 1118, 1115, 1332, 1345, 1308, 1345, 1339, 1346,

     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1309, 1332,
     1114, 1340, 1332, 1105, 1308, 1083, 1313, 1082, 1335, 1082,
     1317, 1335, 1355, 1312, 1355, 1081, 1356, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1335, 1374, 1080, 1335, 1079,
     1312, 1078,  953, 1076, 1375, 1071, 1435, 1435, 1359, 1435,
     1359, 1066, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
     1360, 1065, 1309, 1342, 1332, 1064, 1063, 1332, 1062, 1308,
     1061, 1377, 1335, 1338, 1353, 1335, 1338, 1312, 1316, 1060,
     1052, 1051, 1354, 1354, 1354, 1354, 1050, 1036, 1313, 1034,
     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,

     1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
     1354, 1354, 1354, 1354, 1354, 1354, 1033, 1309, 1335, 1032,
     1031, 1335, 1030, 1312, 1029, 1378, 1380, 1338, 1357, 1028,
     1338, 1019, 1316, 1018, 1004, 1002, 1358, 1358, 1358, 1358,
     1001,  998,  995,  972, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
     1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
      994, 1313, 1338, 1186,  991, 1338, 1186, 1316, 1187,  990,
     1381, 1186, 1361,  981, 1186,  959, 1187,  958,  957,  956,
     1362, 1362, 1362, 1362,  950,  949,  948,  947, 1362, 1362,

     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
     1362, 1362, 1362, 1362, 1338, 1317, 1188, 1338,  947, 1316,
      946,  694,  943,  834, 1188, 1332, 1435, 1363, 1332, 1363,
     1308, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1346, 1306,
     1435, 1435, 1435, 1310, 1435, 1435,  921, 1306, 1306, 1306,
     1306, 1310, 1310, 1310, 1310,  920, 1314, 1317, 1332,  917,
      914, 1332,  753, 1308, 1314, 1314, 1314, 1314, 1375, 1306,
     1332,  913,  910, 1332, 1384, 1308,  909, 1306, 1306, 1306,

     1306,  900,  898,  897, 1373, 1373, 1373, 1373, 1373, 1373,
     1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
     1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
     1332, 1309,  894, 1332,  891, 1308,  868,  890,  887, 1335,
      886,  877, 1335, 1374, 1312,  855,  854, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1356, 1360, 1360, 1360, 1360,
     1360, 1360, 1360, 1360, 1360, 1310,  853,  852,  848, 1314,
      847,  846,  845, 1310, 1310, 1310, 1310, 1314, 1314, 1314,
     1314,  844,  710, 1309, 1335,  704,  704, 1335,  843, 1312,
      837,  828, 1313, 1335,  826,  824, 1335, 1335, 1312,  824,

     1335, 1338, 1312,  659, 1338, 1435, 1316, 1435, 1435, 1435,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376, 1376, 1376, 1376, 1435, 1313, 1338, 1435,
      801, 1338,  801, 1316, 1332,  799, 1378, 1332,  799, 1308,
     1377,  800,  798, 1435, 1381,  762,  762,  725,  725,  723,
      723,  721,  720,  719, 1379, 1379, 1379, 1379, 1379, 1379,
     1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
     1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
     1338, 1317,  718, 1338,  717, 1316, 1332, 1309,  716, 1332,

     1335, 1308,  715, 1335,  714, 1312, 1333, 1364, 1364, 1364,
     1364, 1364, 1364, 1364, 1364, 1364,  709, 1335,  708, 1386,
     1335, 1338, 1312,  694, 1338, 1338, 1316,  530, 1338, 1338,
     1316,  527, 1338,  689, 1316,  685,  684,  683,  676, 1435,
      305,  663,  662, 1317,  478,  661, 1435, 1435, 1435, 1309,
      619, 1435, 1435, 1313, 1435,  449, 1435,  577, 1387,  577,
      569,  568, 1336,  567,  566,  565,  564,  563,  559,  559,
     1313, 1334,  557,  557, 1317, 1388,  554,  553, 1317, 1389,
      552,  549, 1380, 1339,  546,  365, 1332, 1391,  545, 1332,
      544, 1308, 1337,  543,  534,  356, 1390,  353,  528, 1396,

     1340, 1396,  527, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
     1397, 1397,  345,  521,  520,  519,  518,  517,  516,  510,
      510,  509,  508,  506,  505,  502,  152,  305,  482,  482,
      480,  480,  481,  479,  477,  288,  474,  469,  468, 1309,
     1398,  465,  456,  452,  449, 1435,  396,  394, 1399, 1399,
     1399, 1399,  392,  226,  224,  219, 1399, 1399, 1399, 1399,
     1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
     1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
     1399, 1399, 1335,  380,  376, 1335,  378, 1312,  376,  374,
      373,  207,  201,  204,  203, 1400,  194, 1400,  203, 1401,

     1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,  339,  338,
      337,  336,  335,  334,  321,  152,  299,  297,  294,  293,
      275,  274,  238,  125,  124,  238,  104,  223,  222,  212,
      211,  210,  209,  204,  203, 1313, 1402,  199,  187,  185,
      183,  181,  180,  179, 1403, 1403, 1403, 1403,  178,  172,
      170,  160, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
     1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
     1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1338,  159,
      156, 1338,  127, 1316,  125,  124,  108, 1435,  102,  102,
       38, 1404,   38, 1404, 1435, 1405, 1405, 1405, 1405, 1405,

     1405, 1405, 1405, 1405, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1317, 1406, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1407, 1407, 1407, 1407, 1435, 1435, 1435, 1435, 1407, 1407,
     1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407,
     1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407, 1407,
     1407, 1407, 1407, 1407, 1332, 1435, 1435, 1332, 1435, 1308,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,

     1435, 1335, 1435, 1435, 1335, 1435, 1312, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1401, 1401,
     1401, 1401, 1401, 1401, 1401, 1401, 1401, 1309, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1313, 1413, 1413, 1413, 1413, 1413,
     1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413,
     1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413, 1413,
     1413, 1338, 1435, 1435, 1338, 1435, 1316, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1405, 1405,

     1405, 1405, 1405, 1405, 1405, 1405, 1405, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1317, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   56,   56,   56,   56,   56,   56,   56,
       56,   56,   56,   56,   68,   68,   68,   68,   68,   68,

       68,   68,   68,   68,   68,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   94,   94,
       94,   94,   94,   94,   94,   94,   94,   94,   94,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
      101,  101,  101,  101,  101,  101,  101,  101,  101,  101,
      101,  114,  114,  114,  114,  114,  114,  114,  114,  114,
      114,  114,  128,  128,  128,  128,  161,  161, 1435,  161,
      161,  161,  161,  161,  161,  161,  161,  171, 1435, 1435,

     1435,  171,  171,  171,  171,  171,  171,  171,  176,  176,
     1435, 1435,  176,  176,  176,  176,  176,  176,  176,  182,
      182, 1435,  182,  182,  182,  182,  182,  182,  182,  182,
      184, 1435, 1435, 1435,  184,  184,  184,  184,  184,  184,
      184,  186, 1435, 1435, 1435,  186,  186,  186,  186,  186,
      186,  186,  188, 1435, 1435, 1435,  188,  188,  188,  188,
      188,  188,  188,  205,  205, 1435,  205,  205,  205,  205,
      205,  205,  205,  205,  213,  213, 1435,  213,  213,  213,
      213,  213,  213,  213,  213,  218,  218, 1435,  218,  218,
      218,  218,  218,  218,  218,  218,  228,  228, 1435,  228,

      228,  228,  228,  228,  228,  228,  228,  243,  243,  243,
      243,  243,  243,  243,  243,  243,  243,  243,  128,  128,
      128,  128,  277,  277, 1435,  277,  277,  277,  277,  277,
      277,  277,  277,  279,  279, 1435,  279,  279,  279,  279,
      279,  279,  279,  279,  287,  287, 1435,  287,  287,  287,
      287,  287,  287,  287,  287,  292,  292, 1435,  292,  292,
      292,  292,  292,  292,  292,  292,  295, 1435,  295,  295,
      296,  296,  298, 1435, 1435,  298,  298,  171, 1435, 1435,
     1435,  171,  171,  171,  171,  171,  171,  171,  176,  176,
     1435, 1435,  176,  176,  176,  176,  176,  176,  176,  182,

      182, 1435,  182,  182,  182,  182,  182,  182,  182,  182,
      184, 1435, 1435, 1435,  184,  184,  184,  184,  184,  184,
      184,  186, 1435, 1435, 1435,  186,  186,  186,  186,  186,
      186,  186,  188, 1435, 1435, 1435,  188,  188,  188,  188,
      188,  188,  188,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  352,  352, 1435,  352,  352,  352,
      352,  352,  352,  352,  352,  375,  375, 1435,  375,  375,
      375,  375,  375,  375,  375,  375,  377,  377, 1435,  377,
      377,  377,  377,  377,  377,  377,  377,  218,  218, 1435,
      218,  218,  218,  218,  218,  218,  218,  218,  228,  228,

     1435,  228,  228,  228,  228,  228,  228,  228,  228,  401,
      401,  401,  401,  401,  401,  401,  401,  401,  401,  401,
      287,  287, 1435,  287,  287,  287,  287,  287,  287,  287,
      287,  476,  476, 1435,  476,  476,  476,  476,  476,  476,
      476,  476,  277,  277, 1435,  277,  277,  277,  277,  277,
      277,  277,  277,  478,  478, 1435,  478,  478,  478,  478,
      478,  478,  478,  478,  483,  483, 1435,  483,  483,  483,
      483,  483,  483,  483,  483,  484,  484, 1435,  484,  484,
      484,  484,  484,  484,  484,  484,  485,  485,  485,  485,
      485, 1435,  485,  485,  485,  485,  485,  486,  486, 1435,

      486,  486,  486,  486,  486,  486,  486,  486,  488,  488,
      489,  489,  489,  489, 1435,  489,  489,  489,  489,  489,
      489,  490,  490,  490,  490,  490, 1435,  490,  490,  490,
      490,  490,  522,  522, 1435,  522,  522,  522,  522,  522,
      522,  522,  522,  343,  343,  343,  343,  343,  343,  343,
      343,  343,  343,  343,  529,  529, 1435,  529,  529,  529,
      529,  529,  529,  529,  529,  555,  555, 1435,  555,  555,
      555,  555,  555,  555,  555,  555,  556,  556, 1435,  556,
      556,  556,  556,  556,  556,  556,  556,  558,  558, 1435,
      558,  558,  558,  558,  558,  558,  558,  558,  562,  562,

     1435,  562,  562,  562,  562,  562,  562,  562,  562,  570,
      570, 1435,  570,  570,  570,  570,  570,  570,  570,  570,
      228,  228, 1435,  228,  228,  228,  228,  228,  228,  228,
      228,  608,  608, 1435,  608,  608,  608,  608,  608,  608,
      608,  608,  610,  610, 1435,  610,  610,  610,  610,  610,
      610,  610,  610,  618,  618, 1435,  618,  618,  618,  618,
      618,  618,  618,  618,  651,  651, 1435,  651,  651,  651,
      651,  651,  651,  651,  651,  655,  655, 1435,  655,  655,
      655,  655,  655,  655,  655,  655,  476,  476, 1435,  476,
      476,  476,  476,  476,  476,  476,  476,  659,  659, 1435,

      659,  659,  659,  659,  659,  659,  659,  659,  660,  660,
     1435,  660,  660,  660,  660,  660,  660,  660,  660,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
      298,  298,  489,  489,  489,  489,  489,  489,  489,  489,
      489,  489,  489,  490,  490,  490,  490,  490,  490,  490,
      490,  490,  490,  490,  610,  610, 1435,  610,  610,  610,
      610,  610,  610,  610,  610,  522,  522, 1435,  522,  522,
      522,  522,  522,  522,  522,  522,  692,  692, 1435,  692,
      692,  692,  692,  692,  692,  692,  692,  555,  555, 1435,
      555,  555,  555,  555,  555,  555,  555,  555,  722,  722,

     1435,  722,  722,  722,  722,  722,  722,  722,  722,  724,
      724, 1435,  724,  724,  724,  724,  724,  724,  724,  724,
      761,  761, 1435,  761,  761,  761,  761,  761,  761,  761,
      761,  570,  570, 1435,  570,  570,  570,  570,  570,  570,
      570,  570,  763,  763, 1435,  763,  763,  763,  763,  763,
      763,  763,  763,  764,  764, 1435,  764,  764,  764,  764,
      764,  764,  764,  764,  228,  228, 1435,  228,  228,  228,
      228,  228,  228,  228,  228,  765,  765, 1435,  765,  765,
      765,  765,  765,  765,  765,  765,  766,  766, 1435,  766,
      766,  766,  766,  766,  766,  766,  766,  767,  767, 1435,

      767,  767,  767,  767,  767,  767,  767,  767,  771,  771,
     1435,  771,  771,  771,  771,  771,  771,  771,  771,  791,
      791, 1435,  791,  791,  791,  791,  791,  791,  791,  791,
      795,  795, 1435,  795,  795,  795,  795,  795,  795,  795,
      795,  608,  608, 1435,  608,  608,  608,  608,  608,  608,
      608,  608,  797,  797, 1435,  797,  797,  797,  797,  797,
      797,  797,  797,  802,  802, 1435,  802,  802,  802,  802,
      802,  802,  802,  802,  803,  803,  803,  803,  803,  803,
      803,  803,  803,  803,  803,  806,  806,  806,  806,  806,
      806,  806,  806,  806,  806,  806,  807,  807,  807,  807,

      807,  807,  807,  807,  807,  807,  807,  808,  808, 1435,
      808,  808,  808,  808,  808,  808,  808,  808,  809,  809,
     1435,  809,  809,  809,  809,  809,  809,  809,  809,  810,
      810, 1435,  810,  810,  810,  810,  810,  810,  810,  810,
      811,  811, 1435,  811,  811,  811,  811,  811,  811,  811,
      811,  812,  812, 1435,  812,  812,  812,  812,  812,  812,
      812,  812,  813,  813, 1435,  813,  813,  813,  813,  813,
      813,  813,  813,  651,  651, 1435,  651,  651,  651,  651,
      651,  651,  651,  651,  814,  814, 1435,  814,  814,  814,
      814,  814,  814,  814,  814,  655,  655, 1435,  655,  655,

      655,  655,  655,  655,  655,  655,  815, 1435,  815,  815,
      815,  815,  815,  815,  815,  815,  815,  797,  797, 1435,
      797,  797,  797,  797,  797,  797,  797,  797,  522,  522,
      522,  522,  522,  522,  522,  522,  522,  522,  522,  831,
      831, 1435,  831,  831,  831,  831,  831,  831,  831,  831,
      856,  856, 1435,  856,  856,  856,  856,  856,  856,  856,
      856,  722,  722, 1435,  722,  722,  722,  722,  722,  722,
      722,  722,  857,  857, 1435,  857,  857,  857,  857,  857,
      857,  857,  857,  724,  724, 1435,  724,  724,  724,  724,
      724,  724,  724,  724,  922,  922, 1435,  922,  922,  922,

      922,  922,  922,  922,  922,  761,  761, 1435,  761,  761,
      761,  761,  761,  761,  761,  761,  763,  763, 1435,  763,
      763,  763,  763,  763,  763,  763,  763,  764,  764, 1435,
      764,  764,  764,  764,  764,  764,  764,  764,  765,  765,
     1435,  765,  765,  765,  765,  765,  765,  765,  765,  766,
      766, 1435,  766,  766,  766,  766,  766,  766,  766,  766,
      767,  767, 1435,  767,  767,  767,  767,  767,  767,  767,
      767,  771,  771, 1435,  771,  771,  771,  771,  771,  771,
      771,  771,  925,  925, 1435,  925,  925,  925,  925,  925,
      925,  925,  925,  926,  926, 1435,  926,  926,  926,  926,

      926,  926,  926,  926,  927,  927, 1435,  927,  927,  927,
      927,  927,  927,  927,  927,  928,  928, 1435,  928,  928,
      928,  928,  928,  928,  928,  928,  929,  929, 1435,  929,
      929,  929,  929,  929,  929,  929,  929,  930,  930, 1435,
      930,  930,  930,  930,  930,  930,  930,  930,  791,  791,
     1435,  791,  791,  791,  791,  791,  791,  791,  791,  931,
      931, 1435,  931,  931,  931,  931,  931,  931,  931,  931,
      795,  795, 1435,  795,  795,  795,  795,  795,  795,  795,
      795,  933,  933, 1435,  933,  933,  933,  933,  933,  933,
      933,  933,  803,  803,  803,  803,  803,  803,  803,  803,

      803,  803,  803,  806,  806,  806,  806,  806,  806,  806,
      806,  806,  806,  806,  807,  807,  807,  807,  807,  807,
      807,  807,  807,  807,  807,  808,  808, 1435,  808,  808,
      808,  808,  808,  808,  808,  808,  809,  809, 1435,  809,
      809,  809,  809,  809,  809,  809,  809,  810,  810, 1435,
      810,  810,  810,  810,  810,  810,  810,  810,  811,  811,
     1435,  811,  811,  811,  811,  811,  811,  811,  811,  812,
      812, 1435,  812,  812,  812,  812,  812,  812,  812,  812,
      813,  813, 1435,  813,  813,  813,  813,  813,  813,  813,
      813,  814,  814, 1435,  814,  814,  814,  814,  814,  814,

      814,  814,  815, 1435,  815,  815,  815,  815,  815,  815,
      815,  815,  815,  940,  940, 1435,  940,  940,  940,  940,
      940,  940,  940,  940,  960,  960, 1435,  960,  960,  960,
      960,  960,  960,  960,  960,  961,  961, 1435,  961,  961,
      961,  961,  961,  961,  961,  961, 1053, 1435, 1053, 1053,
     1067, 1067, 1435, 1067, 1067, 1067, 1067, 1067, 1067, 1067,
     1067,  925,  925, 1435,  925,  925,  925,  925,  925,  925,
      925,  925,  926,  926, 1435,  926,  926,  926,  926,  926,
      926,  926,  926,  927,  927, 1435,  927,  927,  927,  927,
      927,  927,  927,  927,  928,  928, 1435,  928,  928,  928,

      928,  928,  928,  928,  928,  929,  929, 1435,  929,  929,
      929,  929,  929,  929,  929,  929,  930,  930, 1435,  930,
      930,  930,  930,  930,  930,  930,  930,  931,  931, 1435,
      931,  931,  931,  931,  931,  931,  931,  931, 1068, 1068,
     1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1069,
     1069, 1435, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1084, 1084, 1435, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
     1084, 1085, 1085, 1435, 1085, 1085, 1085, 1085, 1085, 1085,
     1085, 1085, 1211, 1211, 1435, 1211, 1211, 1211, 1211, 1211,
     1211, 1211, 1211, 1212, 1212, 1435, 1212, 1212, 1212, 1212,

     1212, 1212, 1212, 1212, 1219, 1219, 1219, 1219, 1219, 1219,
     1219, 1219, 1219, 1219, 1219, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1225, 1225, 1225, 1225,
     1225, 1225, 1225, 1225, 1225, 1225, 1225, 1230, 1230, 1435,
     1230, 1230, 1230, 1230, 1230, 1230, 1230, 1230, 1053, 1435,
     1053, 1435, 1053, 1053, 1257, 1257, 1435, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1272, 1435, 1272, 1272, 1279,
     1435, 1279, 1279, 1306, 1306, 1435, 1306, 1306, 1306, 1306,
     1306, 1306, 1306, 1306, 1310, 1310, 1435, 1310, 1310, 1310,
     1310, 1310, 1310, 1310, 1310, 1314, 1314, 1435, 1314, 1314,

     1314, 1314, 1314, 1314, 1314, 1314, 1348, 1435, 1348, 1348,
       37, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435
    } ;

static const flex_int16_t yy_chk[7441] =
    {   0,
        0,    0,    3,    3,    4,    4,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    7,    7,    7,    7,    8,
        8,    8,    8,   15,    9,   10,   25,   25,   25,   25,
        7,   27,   27,   27,    8,   26,   26,   26,   26,  248,
       25,   25,    9,   10,   28,   28,   28,   29,   30,   26,
       26,   33,   33,  248,   29,   30,   34,   34,   15, 1089,
       48,   29,   30,   48,   15,  368,   15,  368,    7,    9,
       10,   59,    8,  258,   59,   40,   40,   40,   40,   25,

       55,   25,  258,   67,   40,   55,   67, 1618,   26,   15,
       26,   40, 1089,   66,   66,   15,   66,   15,   87,   87,
        9,   10,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       16,   43,   43,   43,   43,  232,  281,  281,   44,   44,
       44,   44,  232,  305,  305,   43,   43,   44,   44,   86,

       86,   86,   86,   44,   44,   60,   60,   60,   60,   60,
       60,   60,   99,   99, 1096,   16,   91,   91,   91,   91,
     1613,   16,  267,   16,  104,  104, 1612,   99,  103,  103,
      103,  103,  104,  267,   43,  108,  108,  108,  108,  104,
      111,   44,  126,  111,  108,  126,   16,  127,  318,  318,
      127,  108,   16, 1096,   16,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   45,   45,   45,   45,  136,  122,  135,  136,
      358,  122,  113,   52,  122,  130,   52,   45,  130,  113,
       53,   53,   53,   53,  113,   83,  113,   52,   83,   53,
       53,   84,   84,   84,   84,  138,   53,  423,  138,   83,
       83,  358, 1601,  148,  138,   97,  148,  739,   97,  739,
      135,  122,  148,  246, 1123,   45,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   52,   51,  130,  150,
       51,   51,   51,   53,  163,   84,  247,  163,   83,  161,
      161,  161,  161,  150,   84,  113,   84,   97,  109,  109,
      109,  109,   51,  113,  164,  440,   97,  164,  151,  151,
      151,  151,  109,  109, 1103,  246,  165,   51,   51,  165,
      423,   51,   51,   51,   51,   51,   51,   51,   97,   51,
     1115,  166,   51,   51,  166,   51,   51,   51,  247,   51,
       51,   51,   51,   51,   51,   51,  107,   51,   51,   51,
     1123,  109,  150,  107,  110,  110,  110,  110,  107, 1512,
      150,  151,  107,  107,  107,  167,  107,  315,  167,  110,

      115,  115,  115,  115,  116,  116,  116,  116,  315,  168,
      440,  107,  168,  116,  116,  115,  219,  219,  169,  116,
      116,  169,  370,  370,  107,  117,  117,  117,  117,  222,
      222,  219,  123,  123,  123,  123,  176,  110, 1103,  176,
      117,  123,  123,  177,  222, 1115,  177,  123,  123,  398,
      398,  235,  149,  115,  235,  149,  493,  116,  132,  132,
      132,  132,  132,  132,  132,  132,  149, 1126,  193,  134,
      155,  193,  155,  134,  155,  134,  134,  155,  117,  121,
      121,  134,  121,  193,  238,  123,  134,  238,  259,  134,
      162,  259,  147,  162,  147,  121,  147,  147,  147,  147,

      147,  147,  147,  147,  147,  149,  121,  360,  162,  162,
      162,  162,  121,  121,  155,  361,  121,  259,  121, 1490,
      121,  193,  121,  121,  121,  416,  121,  263,  121,  259,
      263,  493,  121,  190,  190,  190,  190,  121,  360,  121,
      621,  121,  154,  154,  121,  154,  361,  154,  621,  121,
      152,  152,  152,  152,  121,  154,  154,  404,  189,  152,
      152,  189,  154,  268,  268,  268,  152,  156,  156,  156,
      156,  404,  189,  189,  157, 1126,  156,  156,  157,  196,
      157,  157,  203,  156,  416,  203,  157,  191,  191,  191,
      191,  157,  420,  416,  157,  194,  194,  194,  194,  196,

      408,  239,  191,  152,  239,  199,  199,  199,  199,  239,
      196,  189,  200,  200,  200,  200,  201,  201,  201,  201,
      156,  206,  206,  206,  206,  209,  209,  209,  209,  229,
      196,  216,  229,  251,  251,  203,  251,  226,  226,  194,
      207,  207,  207,  207,  230,  226,  580,  230,  194,  199,
      194,  221,  226,  221,  273,  495,  580,  273,  199,  216,
      199,  420,  221,  229,  221,  276,  221,  207,  276,  413,
      216,  230,  229,  221,  207,  207,  216,  233,  207,  207,
      237,  207,  408,  233,  424,  207,  254,  230,  233,  254,
      216,  237,  407,  230,  233,  260,  407,  237,  260,  221,

      233,  216,  260,  307,  307,  207,  307,  216, 1481,  413,
      290,  237,  260,  290,  233,  240,  240,  240,  240,  290,
      254,  321,  237,  322,  321,  233,  322,  495,  237,  254,
      240,  233,  241,  241,  241,  241,  242,  242,  242,  242,
      244,  244,  244,  244,  424,  302,  415,  241,  302,  256,
      323,  242,  256,  323,  302,  244,  307,  496, 1124,  207,
      207,  207,  207,  756,  207,  756,  207,  207,  240,  245,
      245,  245,  245,  546,  546,  324,  256,  261,  324,  304,
      304,  304,  304,  261,  245,  241,  415,  446,  261,  242,
      256,  446,  256,  244,  261,  545,  270,  533,  256,  312,

      261,  325,  312,  326,  325,  327,  326,  270,  327,  328,
      427,  769,  328,  270,  261,  329,  330,  331,  329,  330,
      331,  632,  245,  249,  249,  261,  249,  270,  533,  632,
      498,  261,  304,  312,  332,  270,  496,  332,  270,  249,
      333, 1434,  312,  333,  270,  340,  340,  340,  340,  545,
      249,  341,  341,  341,  341,  628,  249,  249,  342,  628,
      249,  342,  249, 1433,  249,  697,  249,  249,  249, 1124,
      249,  427,  249,  342,  312,  344,  249,  389,  344,  312,
      389,  249,  697,  249,  390,  249,  391,  390,  249,  391,
      344,  769,  499,  249,  345,  345,  345,  345,  249,  250,

      250,  250,  250,  250,  250,  250,  250,  250,  250,  498,
      250,  342,  347,  250,  250,  250,  300,  300,  300,  300,
      300,  300,  300,  300,  300,  890,  392,  393,  344,  392,
      393,  394,  347,  395,  394,  250,  395,  770,  345,  351,
      351,  351,  351,  347,  425,  396, 1093,  345,  396,  345,
      397,  250,  665,  397,  250,  250,  250,  250,  250,  250,
      250,  451,  250,  347,  451,  250,  250, 1093,  250,  250,
      250,  499,  250,  250,  250,  250,  250,  250,  250,  890,
      250,  250,  250,  309,  309,  913,  309,  379,  379,  379,
      379,  806,  379,  409,  409,  806,  409,  410,  410,  309,

      410,  770,  536,  402,  402,  402,  402,  362,  425,  309,
      309,  362,  309, 1182,  309,  362,  309,  309,  402,  425,
      309,  362,  309,  309,  309,  421,  309,  309,  309,  309,
      309,  665,  309,  536,  437,  437,  309,  437,  362,  913,
      538,  309,  362,  309,  426,  309,  362,  452,  309,  871,
      452,  871,  362,  309,  430,  430,  402,  430,  309,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  453,
      310,  538,  453,  310,  310,  310, 1151,  539,  403,  403,
      403,  403,  421,  612,  612,  421,  405,  405,  405,  405,
      497,  439,  439,  403,  439,  310,  540,  672,  672,  362,

      439,  405,  741,  741,  426,  426,  426,  430,  539,  454,
      455,  310,  454,  455,  310,  310,  310,  310,  310,  310,
      310,  456,  310, 1182,  456,  310,  310,  540,  310,  310,
      310,  403,  310,  310,  310,  310,  310,  310,  310,  405,
      310,  310,  310,  353,  353,  353,  353, 1164,  406,  693,
      406, 1164,  355,  355,  355,  355,  457,  406,  497,  457,
      417,  417,  406,  417,  406,  356,  356,  356,  356,  497,
      353,  412,  412,  458,  412, 1151,  458,  353,  353,  355,
      693,  353,  353,  418,  353, 1120,  355,  355,  353,  417,
      355,  355,  356,  355,  735,  414,  414,  355,  414,  356,

      356,  417,  695,  356,  356,  412,  356,  735,  353,  418,
      356,  752,  418,  975,  412,  975,  418,  355,  448,  448,
     1094,  448,  414,  406,  752,  459,  418,  448,  459,  450,
      356,  406,  450,  695,  450,  432,  414,  460,  414,  461,
      460,  994,  461,  462,  414,  463,  462, 1432,  463,  698,
      428,  419,  432,  432,  432,  432,  432,  432,  432,  432,
      758,  758,  353,  353,  353,  353,  699,  353,  867,  353,
      353,  355,  355,  355,  355,  948,  355,  419,  355,  355,
      698,  867,  428,  419,  356,  356,  356,  356,  419,  356,
      948,  356,  356,  428,  419,  994,  701,  699,  435,  428,

      419, 1120,  435,  464,  435,  435,  464, 1431,  465,  466,
      435,  465,  466,  428,  419,  435,  467,  468,  435,  467,
      468,  428,  447,  471,  428,  419,  471,  701,  768,  803,
      428,  419,  422, 1094,  447, 1156,  447,  803,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  472,  473,  475,
      472,  473,  475,  477,  849,  849,  477,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  443,  480,  502,  504,  480,  502,  504,
     1430,  443,  443,  443,  443,  505,  768,  768,  505,  443,

      443,  443,  443,  443,  443,  443,  443,  443,  443,  443,
      443,  443,  443,  443,  443,  443,  443,  443,  443,  443,
      443,  443,  443,  443,  443,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  506,  507, 1156,  506,  507,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  445,  508,  509,  511,  508,  509,  511,  512,
      513,  514,  512,  513,  514,  703,  851,  851,  445,  445,

      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  515,  520,  703,  515,  520,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  469, 1429,  519,  469,  492,
      519,  492, 1007,  494,  494,  500,  494,  573,  535,  500,
      573,  500,  500,  469, 1097,  492,  519,  500,  523, 1007,
      527,  523,  500,  527,  537,  500,  524,  524,  524,  524,
     1102,  535,  577,  523,  702,  577,  537,  494,  542,  535,

     1039,  524,  542,  578,  637,  537,  494,  637,  702,  537,
      530,  530,  530,  530,  542,  537,  705, 1039,  638,  542,
      469,  638,  850,  532,  532,  532,  532,  537,  707,  581,
      581,  523,  581,  527,  492, 1174,  537,  530,  494,  702,
      537,  850,  492,  494,  530,  530,  807,  705,  530,  530,
      532,  530, 1428,  541,  807,  530,  535,  532,  532,  707,
      971,  532,  532,  578,  532,  541,  578, 1121,  532,  583,
      583,  578,  583,  971,  541,  530,  582,  582,  541,  582,
     1097,  582,  584,  584,  541,  584,  585,  585,  532,  585,
      586,  586, 1102,  586,  587,  587,  541,  587,  588,  588,

     1098,  588,  728,  589,  589,  541,  589,  590,  590,  541,
      590,  591,  591, 1114,  591,  592,  592,  730,  592,  593,
      593, 1174,  593,  594,  594,  639,  594, 1118,  639,  530,
      530,  530,  530,  728,  530, 1100,  530,  530,  595,  595,
      731,  595,  532,  532,  532,  532,  745,  532,  730,  532,
      532,  560,  560,  560,  560, 1114,  560,  596,  596, 1122,
      596,  597,  597,  747,  597,  598,  598, 1148,  598,  599,
      599,  731,  599,  600,  600, 1099,  600,  745,  560,  601,
      601,  640,  601, 1121,  640,  560,  560, 1118,  641,  560,
      560,  641,  560, 1149,  747, 1105,  560,  601,  603,  603,

     1148,  603,  604,  604,  560,  604,  605,  605,  629,  605,
      607,  607, 1098,  607,  620,  620,  560,  620,  644,  645,
     1105,  644,  645,  620,  629,  629,  629,  629,  629,  629,
      629,  629,  629,  631,  631,  647,  631,  648,  647, 1100,
      648, 1118,  631,  649,  601,  650,  649,  653,  650,  654,
      653,  656,  654,  657,  656,  658,  657, 1143,  658,  664,
      664, 1122,  664,  666,  666,  675,  666, 1099,  675, 1099,
      560,  560,  560,  560, 1142,  560, 1175,  560,  560,  561,
      561,  561,  561, 1427,  561,  667,  667, 1170,  667,  668,
      668, 1143,  668,  669,  669, 1142,  669,  670,  670, 1149,

      670,  671,  671, 1176,  671,  676,  561,  677,  676,  678,
      677, 1170,  678,  561,  561, 1125,  679,  561,  561,  679,
      561, 1173,  680,  681,  561,  680,  681,  682,  684,  748,
      682,  684,  561,  686,  687,  688,  686,  687,  688,  689,
      772,  772,  689,  772,  561,  690,  690,  690,  690,  691,
      691,  691,  691,  694,  694,  694,  694,  832,  700,  836,
      748, 1426,  700,  704,  704,  704,  704,  777,  777, 1116,
      777,  700,  778,  778, 1116,  778,  779,  779, 1173,  779,
      780,  780, 1175,  780,  781,  781, 1425,  781,  832,  700,
      836,  784,  784,  700,  784,  873,  873, 1125,  561,  561,

      561,  561,  700,  561, 1150,  561,  561,  623,  717,  785,
      785,  717,  785,  787,  787, 1424,  787,  788,  788, 1176,
      788,  789,  789, 1423,  789,  790,  790,  825,  790, 1422,
      825, 1157,  623,  623,  623,  623,  623,  623,  623,  623,
      623,  623,  623,  623,  623,  623,  623,  623,  623,  623,
      623,  623,  623,  623,  623,  623,  623,  623,  626,  626,
      626,  626,  626,  626,  626,  626,  626,  626,  626,  626,
      626,  626,  626,  626,  626,  626,  626,  626,  626,  626,
      626,  626,  626,  626,  793,  793, 1152,  793, 1150,  626,
      626,  626,  626,  626,  626,  626,  626,  626,  626,  626,

      626,  626,  626,  626,  626,  626,  626,  626,  626,  626,
      626,  626,  626,  626,  626,  706,  706,  706,  706,  794,
      794,  826,  794, 1421,  826,  827,  732,  749,  827,  839,
      732,  749,  717,  717,  732,  749,  796,  796,  840,  796,
      732,  749,  706,  799,  799,  706,  799,  816,  816, 1420,
      816,  817,  817, 1157,  817,  706,  727,  732,  749, 1158,
      839,  732,  749,  727,  727,  732,  749,  727,  727,  840,
      727,  732,  749,  706,  727,  842,  706,  818,  818, 1152,
      818,  828,  727, 1419,  828,  860,  706,  726,  726,  726,
      726,  744,  726,  829,  727, 1418,  829,  830,  744,  744,

      830,  834,  744,  744,  834,  744,  842,  819,  819,  744,
      819, 1417,  820,  820,  726,  820,  860,  744,  732,  749,
     1178,  726,  726,  862,  938,  726,  726,  938,  726,  744,
      821,  821,  726,  821,  822,  822,  863,  822,  823,  823,
      726,  823,  833,  833,  833,  833,  876,  878,  727,  727,
      727,  727,  726,  727,  862,  727,  727,  841,  841,  841,
      841,  879,  881,  882,  883,  891,  891,  863,  899, 1416,
      878,  902,  904,  914,  914,  949,  949,  876,  878,  905,
     1158,  906, 1130,  744,  744,  744,  744, 1130,  744,  941,
      744,  744,  879,  881,  882,  883,  841, 1415,  939,  899,

      885,  939,  902,  904,  885,  901,  726,  726,  726,  726,
      905,  726,  906,  726,  726,  804,  885, 1177,  908, 1411,
      941,  885,  908,  923,  923, 1178,  923,  841,  901,  924,
      924, 1410,  924, 1184,  908,  878,  901,  952,  952,  908,
      804,  804,  804,  804,  804,  804,  804,  804,  804,  804,
      804,  804,  804,  804,  804,  804,  804,  804,  804,  804,
      804,  804,  804,  804,  804,  804,  805,  805,  805,  805,
      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,
      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,
      805,  805,  942,  901, 1409,  942, 1183,  805,  805,  805,

      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,
      805,  805,  805,  805,  805,  805,  805,  805,  805,  805,
      805,  805,  805,  858,  858,  858,  858,  859,  858,  932,
      932, 1184,  932, 1177,  859,  859,  977,  977,  859,  859,
      864,  859,  943,  944,  864,  859,  936,  936,  864,  936,
      858, 1408,  945,  859,  864,  964,  966,  858,  858,  995,
      995,  858,  858, 1154,  858,  859,  937,  937,  858,  937,
      967,  864, 1395,  943,  944,  864,  858,  980,  983,  864,
      985,  986,  880,  945,  987,  864,  964,  966,  858,  947,
      947,  947,  947, 1004,  880, 1394, 1004, 1003, 1004, 1393,

     1005,  967, 1008,  880, 1188, 1183,  982,  880,  980,  983,
     1009,  985,  986,  880,  989,  987, 1392, 1188,  989,  859,
      859,  859,  859, 1011,  859,  880,  859,  859, 1003,  982,
      989, 1005,  864, 1008,  880,  989,  884,  982,  880, 1012,
     1385, 1009,  858,  858,  858,  858, 1004,  858,  884,  858,
      858,  968, 1013, 1012, 1011,  968, 1015,  884, 1017,  968,
     1035,  884, 1153, 1165,  889,  968,  889,  884,  889,  889,
      889,  889,  889,  889,  889,  889,  889, 1037, 1187,  884,
     1154, 1187,  968, 1013, 1012, 1384,  968, 1015,  884, 1017,
      968, 1035,  884,  888,  982, 1031,  968, 1383, 1031, 1205,

     1205,  888,  888,  888,  888, 1165, 1040, 1382, 1037,  888,
      888,  888,  888,  888,  888,  888,  888,  888,  888,  888,
      888,  888,  888,  888,  888,  888,  888,  888,  888,  888,
      888,  888,  888,  888,  888,  903,  907, 1040,  984, 1041,
     1010, 1042, 1043,  968, 1010, 1042, 1119,  903,  907, 1153,
      984, 1044, 1045, 1010, 1042, 1047,  903,  907, 1049,  984,
      903,  907, 1172,  984, 1372, 1044,  903,  907, 1131,  984,
     1041, 1010, 1042, 1043, 1369, 1010, 1042, 1014,  903,  907,
     1014,  984, 1014, 1045, 1010, 1042, 1047,  903,  907, 1049,
      984,  903,  907,  912,  984,  912, 1044,  912,  912,  912,

      912,  912,  912,  912,  912,  912,  962,  962,  962,  962,
      963,  962, 1063, 1068, 1068, 1063, 1068,  963,  963, 1031,
     1031,  963,  963, 1070,  963,  988, 1036, 1246,  963, 1036,
     1014, 1036, 1172,  962, 1206, 1132,  963,  988, 1207, 1207,
      962,  962, 1246, 1366,  962,  962,  988,  962,  963, 1365,
      988,  962, 1131, 1206, 1070, 1046,  988, 1352, 1046,  962,
     1046, 1072, 1072, 1072, 1072, 1119, 1119, 1090,  988, 1131,
     1132,  962, 1073, 1073, 1073, 1073, 1351,  988,  993, 1036,
      993,  988,  993,  993,  993,  993,  993,  993,  993,  993,
      993, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022, 1022,

     1090, 1132,  963,  963,  963,  963, 1350,  963, 1046,  963,
      963, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1078, 1078, 1078, 1078, 1349,  962,  962,  962,  962, 1343,
      962, 1090,  962,  962,  992, 1137, 1063, 1063, 1079, 1079,
     1079, 1079,  992,  992,  992,  992, 1080, 1080, 1080, 1080,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992, 1016, 1107, 1137, 1016,
     1088, 1016, 1021, 1082, 1082, 1082, 1082, 1091, 1127, 1021,
     1021, 1185, 1342, 1021, 1021, 1189, 1021, 1101, 1215, 1160,

     1021, 1215, 1160, 1016, 1160, 1088, 1016, 1023, 1021, 1137,
     1341, 1107, 1091, 1127, 1023, 1023, 1016, 1331, 1023, 1023,
     1021, 1023, 1185, 1095, 1234, 1023, 1189, 1234, 1179, 1016,
     1247, 1247, 1104, 1023, 1016, 1161, 1088, 1016, 1161, 1330,
     1161, 1162, 1107, 1091, 1127, 1023, 1329, 1016, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020, 1021, 1021, 1021, 1021, 1104, 1021,
     1095, 1021, 1021, 1048, 1101, 1101, 1048, 1128, 1048, 1328,
     1128, 1109, 1128, 1095, 1113, 1327, 1180, 1326, 1162, 1023,

     1023, 1023, 1023, 1129, 1023, 1110, 1023, 1023, 1053, 1104,
     1048, 1162, 1111, 1048, 1106, 1053, 1053, 1055, 1133, 1053,
     1053, 1323, 1053, 1048, 1055, 1055, 1053, 1087, 1055, 1055,
     1136, 1055, 1320, 1109, 1053, 1055, 1048, 1129, 1110, 1106,
     1128, 1048, 1318, 1055, 1048, 1111, 1053, 1179, 1179, 1087,
     1135, 1133, 1141, 1304, 1048, 1055, 1087, 1087, 1192, 1136,
     1087, 1087, 1106, 1087, 1109, 1139, 1303, 1087, 1129, 1110,
     1106, 1300, 1134, 1136, 1113, 1087, 1111, 1299, 1113, 1181,
     1180, 1298, 1133, 1138, 1135, 1295, 1138, 1087, 1138, 1192,
     1113, 1250, 1250, 1134, 1139, 1113, 1294, 1134, 1141, 1180,

     1053, 1053, 1053, 1053, 1136, 1053, 1134, 1053, 1053, 1055,
     1055, 1055, 1055, 1293, 1055, 1135, 1055, 1055, 1086, 1086,
     1086, 1086, 1159, 1086, 1134, 1139, 1163, 1106, 1134, 1141,
     1292, 1167, 1289, 1092, 1108, 1155, 1138, 1134, 1155, 1169,
     1155, 1087, 1087, 1087, 1087, 1086, 1087, 1285, 1087, 1087,
     1193, 1159, 1086, 1086, 1092, 1108, 1086, 1086, 1092, 1086,
     1284, 1163, 1092, 1086, 1169, 1195, 1166, 1108, 1092, 1167,
     1112, 1086, 1186, 1213, 1235, 1186, 1108, 1186, 1181, 1181,
     1108, 1193, 1159, 1086, 1239, 1092, 1108, 1166, 1240, 1092,
     1283, 1112, 1163, 1092, 1236, 1169, 1195, 1236, 1108, 1092,

     1167, 1282, 1275, 1112, 1213, 1235, 1302, 1108, 1269, 1302,
     1241, 1108, 1112, 1117, 1268, 1239, 1112, 1264, 1166, 1240,
     1263, 1117, 1112, 1117, 1262, 1117, 1117, 1117, 1117, 1117,
     1117, 1117, 1117, 1117, 1112, 1261, 1145, 1086, 1086, 1086,
     1086, 1241, 1086, 1112, 1086, 1086, 1092, 1112, 1140, 1260,
     1256, 1140, 1168, 1140, 1259, 1168, 1270, 1168, 1145, 1155,
     1155, 1218, 1218, 1218, 1218, 1145, 1145, 1255, 1254, 1145,
     1145, 1291, 1145, 1296, 1253, 1140, 1145, 1319, 1140, 1219,
     1219, 1219, 1219, 1252, 1145, 1259, 1251, 1270, 1140, 1324,
     1249, 1168, 1220, 1220, 1220, 1220, 1145, 1248, 1146, 1147,

     1244, 1140, 1291, 1242, 1296, 1168, 1140, 1344, 1319, 1140,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1140,
     1324, 1147, 1168, 1221, 1221, 1221, 1221, 1237, 1147, 1147,
     1367, 1194, 1147, 1147, 1194, 1147, 1194, 1229, 1344, 1147,
     1222, 1222, 1222, 1222, 1228, 1217, 1216, 1147, 1214, 1171,
     1145, 1145, 1145, 1145, 1171, 1145, 1211, 1145, 1145, 1147,
     1210, 1367, 1171, 1171, 1171, 1171, 1223, 1223, 1223, 1223,
     1194, 1224, 1224, 1224, 1224, 1225, 1225, 1225, 1225, 1226,
     1226, 1226, 1226, 1209, 1194, 1227, 1227, 1227, 1227, 1245,
     1346, 1233, 1245, 1346, 1245, 1346, 1208, 1204, 1233, 1233,

     1203, 1194, 1233, 1233, 1202, 1233, 1201, 1272, 1200, 1233,
     1272, 1199, 1272, 1147, 1147, 1147, 1147, 1233, 1147, 1198,
     1147, 1147, 1265, 1265, 1265, 1265, 1238, 1197, 1238, 1233,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1238, 1243,
     1196, 1243, 1245, 1243, 1243, 1243, 1243, 1243, 1243, 1243,
     1243, 1243, 1266, 1266, 1266, 1266, 1267, 1267, 1267, 1267,
     1272, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,
     1274, 1191, 1190, 1274, 1280, 1274, 1144, 1280, 1085, 1280,
     1084, 1083, 1081, 1233, 1233, 1233, 1233, 1077, 1233, 1076,
     1233, 1233, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1277, 1281, 1075, 1074, 1281, 1071, 1281, 1277, 1277,
     1279, 1286, 1277, 1277, 1286, 1277, 1286, 1279, 1279, 1277,
     1066, 1279, 1279, 1274, 1279, 1065, 1287, 1280, 1279, 1287,
     1288, 1287, 1064, 1288, 1062, 1288, 1297, 1290, 1061, 1277,
     1290, 1301, 1290, 1060, 1297, 1297, 1297, 1297, 1279, 1301,
     1301, 1301, 1301, 1305, 1348, 1281, 1305, 1348, 1305, 1348,
     1306, 1059, 1058, 1306, 1286, 1306, 1307, 1308, 1057, 1307,
     1308, 1307, 1308, 1309, 1056, 1051, 1309, 1310, 1309, 1287,
     1310, 1311, 1310, 1288, 1311, 1050, 1311, 1038, 1034, 1033,
     1290, 1032, 1030, 1277, 1277, 1277, 1277, 1029, 1277, 1028,

     1277, 1277, 1279, 1279, 1279, 1279, 1305, 1279, 1027, 1279,
     1279, 1312, 1313, 1306, 1312, 1313, 1312, 1313, 1314, 1307,
     1308, 1314, 1315, 1314, 1026, 1315, 1309, 1315, 1316, 1025,
     1310, 1316, 1024, 1316, 1311, 1309, 1317, 1019, 1018, 1317,
     1006, 1317, 1321, 1321, 1321, 1321, 1002, 1001, 1309, 1322,
     1322, 1322, 1322, 1000,  999, 1332,  998,  997, 1332,  996,
     1332,  991,  990, 1335, 1312, 1313, 1335, 1338, 1335, 1368,
     1338, 1314, 1338,  981, 1313, 1315,  979, 1368, 1368, 1368,
     1368, 1316,  978, 1354,  976,  974, 1354, 1313, 1354, 1317,
      973, 1356,  972,  970, 1356, 1325, 1356, 1325, 1317, 1325,

     1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1332, 1334,
      969, 1317, 1334,  965, 1334,  959, 1335,  958, 1358,  957,
     1338, 1358, 1334, 1358, 1334,  956, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1334, 1337, 1354,  955, 1337,  954,
     1337,  953,  951,  950, 1356,  946,  935,  934, 1337,  933,
     1337,  921, 1337, 1337, 1337, 1337, 1337, 1337, 1337, 1337,
     1337,  920, 1334, 1321, 1333,  919,  918, 1333,  917, 1333,
      916, 1358, 1360, 1362, 1333, 1360, 1362, 1360, 1362,  915,
      911,  910, 1333, 1333, 1333, 1333,  909,  900, 1337,  898,
     1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333,

     1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333, 1333,
     1333, 1333, 1333, 1333, 1333, 1333,  897, 1333, 1336,  896,
      895, 1336,  894, 1336,  893, 1360, 1362, 1364, 1336,  892,
     1364,  887, 1364,  886,  877,  875, 1336, 1336, 1336, 1336,
      874,  872,  870,  869, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
     1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336, 1336,
      868, 1336, 1339, 1370,  866, 1339, 1370, 1339, 1370,  865,
     1364, 1371, 1339,  861, 1371,  855, 1371,  854,  853,  852,
     1339, 1339, 1339, 1339,  848,  847,  846,  845, 1339, 1339,

     1339, 1339, 1339, 1339, 1339, 1339, 1339, 1339, 1339, 1339,
     1339, 1339, 1339, 1339, 1339, 1339, 1339, 1339, 1339, 1339,
     1339, 1339, 1339, 1339, 1340, 1339, 1370, 1340,  844, 1340,
      843,  838,  837,  835, 1371, 1397,  824, 1340, 1397, 1340,
     1397, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
     1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1373,
      801,  800,  798, 1376,  797,  773,  760, 1373, 1373, 1373,
     1373, 1376, 1376, 1376, 1376,  759, 1379, 1340, 1353,  757,
      755, 1353,  754, 1353, 1379, 1379, 1379, 1379, 1397, 1412,
     1399,  753,  751, 1399, 1370, 1399,  750, 1412, 1412, 1412,

     1412,  746,  743,  742, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1355, 1353,  740, 1355,  738, 1355,  737,  736,  734, 1359,
      733,  729, 1359, 1399, 1359,  721,  720, 1355, 1355, 1355,
     1355, 1355, 1355, 1355, 1355, 1355, 1359, 1359, 1359, 1359,
     1359, 1359, 1359, 1359, 1359, 1413,  719,  718,  716, 1414,
      715,  714,  713, 1413, 1413, 1413, 1413, 1414, 1414, 1414,
     1414,  712,  711, 1355, 1357,  710,  709, 1357,  708, 1357,
      696,  685, 1359, 1401,  683,  674, 1401, 1403, 1401,  673,

     1403, 1405, 1403,  660, 1405,  630, 1405,  627,  625,  624,
     1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
     1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
     1357, 1357, 1357, 1357, 1357, 1357,  622, 1357, 1361,  618,
      617, 1361,  616, 1361, 1374,  615, 1401, 1374,  614, 1374,
     1403,  613,  611,  609, 1405,  563,  562,  559,  558,  557,
      556,  554,  553,  552, 1361, 1361, 1361, 1361, 1361, 1361,
     1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
     1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
     1363, 1361,  551, 1363,  550, 1363, 1375, 1374,  549, 1375,

     1377, 1375,  548, 1377,  547, 1377, 1374, 1363, 1363, 1363,
     1363, 1363, 1363, 1363, 1363, 1363,  544, 1378,  543, 1374,
     1378, 1380, 1378,  534, 1380, 1381, 1380,  531, 1381, 1407,
     1381,  525, 1407,  521, 1407,  518,  517,  516,  503,  501,
      491,  490,  489, 1363,  486,  485,  442,  441,  438, 1375,
      436,  434,  433, 1377,  429,  411,  401,  400, 1375,  399,
      387,  385, 1377,  384,  383,  382,  381,  380,  378,  377,
     1378, 1375,  376,  375, 1380, 1377,  373,  372, 1381, 1378,
      371,  369, 1407, 1380,  367,  366, 1386, 1381,  365, 1386,
      364, 1386, 1378,  363,  359,  357, 1380,  354,  349, 1386,

     1381, 1386,  348, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386,  346,  339,  338,  337,  336,  335,  334,  320,
      319,  317,  316,  314,  313,  311,  308,  306,  286,  285,
      284,  283,  282,  280,  275,  272,  269,  266,  265, 1386,
     1387,  262,  257,  255,  253,  243,  236,  234, 1387, 1387,
     1387, 1387,  231,  227,  225,  220, 1387, 1387, 1387, 1387,
     1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
     1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387,
     1387, 1387, 1388,  217,  215, 1388,  214, 1388,  213,  212,
      210,  208,  202,  198,  197, 1388,  195, 1388,  192, 1388,

     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,  181,  180,
      179,  175,  174,  173,  160,  153,  146,  145,  143,  140,
      125,  124,  120,  119,  118,  112,  105,  102,  100,   96,
       95,   93,   92,   89,   88, 1388, 1389,   85,   81,   78,
       75,   72,   71,   70, 1389, 1389, 1389, 1389,   69,   65,
       62,   58, 1389, 1389, 1389, 1389, 1389, 1389, 1389, 1389,
     1389, 1389, 1389, 1389, 1389, 1389, 1389, 1389, 1389, 1389,
     1389, 1389, 1389, 1389, 1389, 1389, 1389, 1389, 1390,   57,
       54, 1390,   49, 1390,   47,   46,   41,   37,   36,   35,
       18, 1390,   17, 1390,    0, 1390, 1390, 1390, 1390, 1390,

     1390, 1390, 1390, 1390,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 1390, 1391,    0,    0,    0,    0,    0,    0,    0,
     1391, 1391, 1391, 1391,    0,    0,    0,    0, 1391, 1391,
     1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391,
     1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391,
     1391, 1391, 1391, 1391, 1396,    0,    0, 1396,    0, 1396,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,

        0, 1400,    0,    0, 1400,    0, 1400,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 1400, 1400,
     1400, 1400, 1400, 1400, 1400, 1400, 1400, 1396, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1398, 1400, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
     1402, 1404,    0,    0, 1404,    0, 1404,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 1404, 1404,

     1404, 1404, 1404, 1404, 1404, 1404, 1404,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 1404, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
     1406, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436, 1436,
     1436, 1436, 1437, 1437, 1437, 1437, 1437, 1437, 1437, 1437,
     1437, 1437, 1437, 1438, 1438, 1438, 1438, 1438, 1438, 1438,
     1438, 1438, 1438, 1438, 1439, 1439, 1439, 1439, 1439, 1439,

     1439, 1439, 1439, 1439, 1439, 1440, 1440, 1440, 1440, 1440,
     1440, 1440, 1440, 1440, 1440, 1440, 1441, 1441, 1441, 1441,
     1441, 1441, 1441, 1441, 1441, 1441, 1441, 1442, 1442, 1442,
     1442, 1442, 1442, 1442, 1442, 1442, 1442, 1442, 1443, 1443,
     1443, 1443, 1443, 1443, 1443, 1443, 1443, 1443, 1443, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,
     1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445,
     1445, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1447, 1447, 1447, 1447, 1448, 1448,    0, 1448,
     1448, 1448, 1448, 1448, 1448, 1448, 1448, 1449,    0,    0,

        0, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1450, 1450,
        0,    0, 1450, 1450, 1450, 1450, 1450, 1450, 1450, 1451,
     1451,    0, 1451, 1451, 1451, 1451, 1451, 1451, 1451, 1451,
     1452,    0,    0,    0, 1452, 1452, 1452, 1452, 1452, 1452,
     1452, 1453,    0,    0,    0, 1453, 1453, 1453, 1453, 1453,
     1453, 1453, 1454,    0,    0,    0, 1454, 1454, 1454, 1454,
     1454, 1454, 1454, 1455, 1455,    0, 1455, 1455, 1455, 1455,
     1455, 1455, 1455, 1455, 1456, 1456,    0, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1457, 1457,    0, 1457, 1457,
     1457, 1457, 1457, 1457, 1457, 1457, 1458, 1458,    0, 1458,

     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1459, 1459, 1459,
     1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459, 1460, 1460,
     1460, 1460, 1461, 1461,    0, 1461, 1461, 1461, 1461, 1461,
     1461, 1461, 1461, 1462, 1462,    0, 1462, 1462, 1462, 1462,
     1462, 1462, 1462, 1462, 1463, 1463,    0, 1463, 1463, 1463,
     1463, 1463, 1463, 1463, 1463, 1464, 1464,    0, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1465,    0, 1465, 1465,
     1466, 1466, 1467,    0,    0, 1467, 1467, 1468,    0,    0,
        0, 1468, 1468, 1468, 1468, 1468, 1468, 1468, 1469, 1469,
        0,    0, 1469, 1469, 1469, 1469, 1469, 1469, 1469, 1470,

     1470,    0, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1471,    0,    0,    0, 1471, 1471, 1471, 1471, 1471, 1471,
     1471, 1472,    0,    0,    0, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1473,    0,    0,    0, 1473, 1473, 1473, 1473,
     1473, 1473, 1473, 1474, 1474, 1474, 1474, 1474, 1474, 1474,
     1474, 1474, 1474, 1474, 1475, 1475,    0, 1475, 1475, 1475,
     1475, 1475, 1475, 1475, 1475, 1476, 1476,    0, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1477, 1477,    0, 1477,
     1477, 1477, 1477, 1477, 1477, 1477, 1477, 1478, 1478,    0,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1479, 1479,

        0, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1482, 1482,    0, 1482, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1483, 1483,    0, 1483, 1483, 1483, 1483, 1483, 1483,
     1483, 1483, 1484, 1484,    0, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1485, 1485,    0, 1485, 1485, 1485, 1485,
     1485, 1485, 1485, 1485, 1486, 1486,    0, 1486, 1486, 1486,
     1486, 1486, 1486, 1486, 1486, 1487, 1487,    0, 1487, 1487,
     1487, 1487, 1487, 1487, 1487, 1487, 1488, 1488, 1488, 1488,
     1488,    0, 1488, 1488, 1488, 1488, 1488, 1489, 1489,    0,

     1489, 1489, 1489, 1489, 1489, 1489, 1489, 1489, 1491, 1491,
     1492, 1492, 1492, 1492,    0, 1492, 1492, 1492, 1492, 1492,
     1492, 1493, 1493, 1493, 1493, 1493,    0, 1493, 1493, 1493,
     1493, 1493, 1494, 1494,    0, 1494, 1494, 1494, 1494, 1494,
     1494, 1494, 1494, 1495, 1495, 1495, 1495, 1495, 1495, 1495,
     1495, 1495, 1495, 1495, 1496, 1496,    0, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1497, 1497,    0, 1497, 1497,
     1497, 1497, 1497, 1497, 1497, 1497, 1498, 1498,    0, 1498,
     1498, 1498, 1498, 1498, 1498, 1498, 1498, 1499, 1499,    0,
     1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499, 1500, 1500,

        0, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1501,
     1501,    0, 1501, 1501, 1501, 1501, 1501, 1501, 1501, 1501,
     1502, 1502,    0, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1503, 1503,    0, 1503, 1503, 1503, 1503, 1503, 1503,
     1503, 1503, 1504, 1504,    0, 1504, 1504, 1504, 1504, 1504,
     1504, 1504, 1504, 1505, 1505,    0, 1505, 1505, 1505, 1505,
     1505, 1505, 1505, 1505, 1506, 1506,    0, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1507, 1507,    0, 1507, 1507,
     1507, 1507, 1507, 1507, 1507, 1507, 1508, 1508,    0, 1508,
     1508, 1508, 1508, 1508, 1508, 1508, 1508, 1509, 1509,    0,

     1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1510, 1510,
        0, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1511,
     1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511, 1511,
     1513, 1513, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1515, 1515, 1515, 1515, 1515, 1515, 1515,
     1515, 1515, 1515, 1515, 1516, 1516,    0, 1516, 1516, 1516,
     1516, 1516, 1516, 1516, 1516, 1517, 1517,    0, 1517, 1517,
     1517, 1517, 1517, 1517, 1517, 1517, 1518, 1518,    0, 1518,
     1518, 1518, 1518, 1518, 1518, 1518, 1518, 1519, 1519,    0,
     1519, 1519, 1519, 1519, 1519, 1519, 1519, 1519, 1520, 1520,

        0, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1521,
     1521,    0, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521,
     1522, 1522,    0, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1523, 1523,    0, 1523, 1523, 1523, 1523, 1523, 1523,
     1523, 1523, 1524, 1524,    0, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1525, 1525,    0, 1525, 1525, 1525, 1525,
     1525, 1525, 1525, 1525, 1526, 1526,    0, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1527, 1527,    0, 1527, 1527,
     1527, 1527, 1527, 1527, 1527, 1527, 1528, 1528,    0, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1528, 1529, 1529,    0,

     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1530, 1530,
        0, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1531,
     1531,    0, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531,
     1532, 1532,    0, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1533, 1533,    0, 1533, 1533, 1533, 1533, 1533, 1533,
     1533, 1533, 1534, 1534,    0, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1534, 1535, 1535,    0, 1535, 1535, 1535, 1535,
     1535, 1535, 1535, 1535, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1537, 1537, 1537, 1537, 1537,
     1537, 1537, 1537, 1537, 1537, 1537, 1538, 1538, 1538, 1538,

     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1539, 1539,    0,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1540, 1540,
        0, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1541,
     1541,    0, 1541, 1541, 1541, 1541, 1541, 1541, 1541, 1541,
     1542, 1542,    0, 1542, 1542, 1542, 1542, 1542, 1542, 1542,
     1542, 1543, 1543,    0, 1543, 1543, 1543, 1543, 1543, 1543,
     1543, 1543, 1544, 1544,    0, 1544, 1544, 1544, 1544, 1544,
     1544, 1544, 1544, 1545, 1545,    0, 1545, 1545, 1545, 1545,
     1545, 1545, 1545, 1545, 1546, 1546,    0, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1547, 1547,    0, 1547, 1547,

     1547, 1547, 1547, 1547, 1547, 1547, 1548,    0, 1548, 1548,
     1548, 1548, 1548, 1548, 1548, 1548, 1548, 1549, 1549,    0,
     1549, 1549, 1549, 1549, 1549, 1549, 1549, 1549, 1550, 1550,
     1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1550, 1551,
     1551,    0, 1551, 1551, 1551, 1551, 1551, 1551, 1551, 1551,
     1552, 1552,    0, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1553, 1553,    0, 1553, 1553, 1553, 1553, 1553, 1553,
     1553, 1553, 1554, 1554,    0, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1555, 1555,    0, 1555, 1555, 1555, 1555,
     1555, 1555, 1555, 1555, 1556, 1556,    0, 1556, 1556, 1556,

     1556, 1556, 1556, 1556, 1556, 1557, 1557,    0, 1557, 1557,
     1557, 1557, 1557, 1557, 1557, 1557, 1558, 1558,    0, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1559, 1559,    0,
     1559, 1559, 1559, 1559, 1559, 1559, 1559, 1559, 1560, 1560,
        0, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1561,
     1561,    0, 1561, 1561, 1561, 1561, 1561, 1561, 1561, 1561,
     1562, 1562,    0, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1563, 1563,    0, 1563, 1563, 1563, 1563, 1563, 1563,
     1563, 1563, 1564, 1564,    0, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1565, 1565,    0, 1565, 1565, 1565, 1565,

     1565, 1565, 1565, 1565, 1566, 1566,    0, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1567, 1567,    0, 1567, 1567,
     1567, 1567, 1567, 1567, 1567, 1567, 1568, 1568,    0, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1569, 1569,    0,
     1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569, 1570, 1570,
        0, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1571,
     1571,    0, 1571, 1571, 1571, 1571, 1571, 1571, 1571, 1571,
     1572, 1572,    0, 1572, 1572, 1572, 1572, 1572, 1572, 1572,
     1572, 1573, 1573,    0, 1573, 1573, 1573, 1573, 1573, 1573,
     1573, 1573, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,

     1574, 1574, 1574, 1575, 1575, 1575, 1575, 1575, 1575, 1575,
     1575, 1575, 1575, 1575, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1577, 1577,    0, 1577, 1577,
     1577, 1577, 1577, 1577, 1577, 1577, 1578, 1578,    0, 1578,
     1578, 1578, 1578, 1578, 1578, 1578, 1578, 1579, 1579,    0,
     1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1580, 1580,
        0, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1581,
     1581,    0, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581,
     1582, 1582,    0, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1583, 1583,    0, 1583, 1583, 1583, 1583, 1583, 1583,

     1583, 1583, 1584,    0, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1585, 1585,    0, 1585, 1585, 1585, 1585,
     1585, 1585, 1585, 1585, 1586, 1586,    0, 1586, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1587, 1587,    0, 1587, 1587,
     1587, 1587, 1587, 1587, 1587, 1587, 1588,    0, 1588, 1588,
     1589, 1589,    0, 1589, 1589, 1589, 1589, 1589, 1589, 1589,
     1589, 1590, 1590,    0, 1590, 1590, 1590, 1590, 1590, 1590,
     1590, 1590, 1591, 1591,    0, 1591, 1591, 1591, 1591, 1591,
     1591, 1591, 1591, 1592, 1592,    0, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1592, 1593, 1593,    0, 1593, 1593, 1593,

     1593, 1593, 1593, 1593, 1593, 1594, 1594,    0, 1594, 1594,
     1594, 1594, 1594, 1594, 1594, 1594, 1595, 1595,    0, 1595,
     1595, 1595, 1595, 1595, 1595, 1595, 1595, 1596, 1596,    0,
     1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1597, 1597,
     1597, 1597, 1597, 1597, 1597, 1597, 1597, 1597, 1597, 1598,
     1598,    0, 1598, 1598, 1598, 1598, 1598, 1598, 1598, 1598,
     1599, 1599,    0, 1599, 1599, 1599, 1599, 1599, 1599, 1599,
     1599, 1600, 1600,    0, 1600, 1600, 1600, 1600, 1600, 1600,
     1600, 1600, 1602, 1602,    0, 1602, 1602, 1602, 1602, 1602,
     1602, 1602, 1602, 1603, 1603,    0, 1603, 1603, 1603, 1603,

     1603, 1603, 1603, 1603, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1605, 1605, 1605, 1605, 1605,
     1605, 1605, 1605, 1605, 1605, 1605, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1607, 1607,    0,
     1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607, 1608,    0,
     1608,    0, 1608, 1608, 1609, 1609,    0, 1609, 1609, 1609,
     1609, 1609, 1609, 1609, 1609, 1610,    0, 1610, 1610, 1611,
        0, 1611, 1611, 1614, 1614,    0, 1614, 1614, 1614, 1614,
     1614, 1614, 1614, 1614, 1615, 1615,    0, 1615, 1615, 1615,
     1615, 1615, 1615, 1615, 1615, 1616, 1616,    0, 1616, 1616,

     1616, 1616, 1616, 1616, 1616, 1616, 1617,    0, 1617, 1617,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexgrog.l"

#line 19 "lexgrog.l"

/*
 * lexgrog.l: extract 'whatis' info from nroff man / formatted cat pages.
 *  
 * Copyright (C) 1994, 1995 Graeme W. Wilford. (Wilf.)
 * Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
 *               2011, 2012 Colin Watson.
 *
 * This file is part of man-db.
 *
 * man-db is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * man-db is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with man-db; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Wed Oct 12 18:46:11 BST 1994  Wilf. (G.Wilford@ee.surrey.ac.uk) 
 * 
 * CJW: Detect grap and vgrind. Understand fill requests. Other improvements
 * in the syntax accepted.
 */

#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "gettext.h"
#define _(String) gettext (String)

#include "error.h"
#include "pipeline.h"
#include "decompress.h"
#include "security.h"
#include "encodings.h"
#include "sandbox.h"

#include "manconv_client.h"

#define YY_READ_BUF_SIZE	1024
#define MAX_NAME		8192

#define ARRAY_SIZE(array) (sizeof (array) / sizeof ((array)[0]))

extern man_sandbox *sandbox;

struct macro {
	const char *name;
	const char *value;
};

static const struct macro glyphs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from groff_char(7), although I have omitted some that are
	 * particularly unlikely to be used in NAME sections.
	 */
	{ "'A", "Á" },
	{ "'C", "Ć" },
	{ "'E", "É" },
	{ "'I", "Í" },
	{ "'O", "Ó" },
	{ "'U", "Ú" },
	{ "'Y", "Ý" },
	{ "'a", "á" },
	{ "'c", "ć" },
	{ "'e", "é" },
	{ "'i", "í" },
	{ "'o", "ó" },
	{ "'u", "ú" },
	{ "'y", "ý" },
	{ ",C", "Ç" },
	{ ",c", "ç" },
	{ "-D", "Ð" },
	{ ".i", "ı" },
	{ "/L", "Ł" },
	{ "/O", "Ø" },
	{ "/l", "ł" },
	{ "/o", "ø" },
	{ ":A", "Ä" },
	{ ":E", "Ë" },
	{ ":I", "Ï" },
	{ ":O", "Ö" },
	{ ":U", "Ü" },
	{ ":Y", "Ÿ" },
	{ ":a", "ä" },
	{ ":e", "ë" },
	{ ":i", "ï" },
	{ ":o", "ö" },
	{ ":u", "ü" },
	{ ":y", "ÿ" },
	{ "AE", "Æ" },
	{ "Bq", "„" },
	{ "Fc", "»" },
	{ "Fi", "ffi" },
	{ "Fl", "ffl" },
	{ "Fo", "«" },
	{ "IJ", "Ĳ" },
	{ "OE", "Œ" },
	{ "Sd", "ð" },
	{ "TP", "Þ" },
	{ "Tp", "þ" },
	{ "^A", "Â" },
	{ "^E", "Ê" },
	{ "^I", "Î" },
	{ "^O", "Ô" },
	{ "^U", "Û" },
	{ "^a", "â" },
	{ "^e", "ê" },
	{ "^i", "î" },
	{ "^o", "ô" },
	{ "^u", "û" },
	{ "`A", "À" },
	{ "`E", "È" },
	{ "`I", "Ì" },
	{ "`O", "Ò" },
	{ "`U", "Ù" },
	{ "`a", "à" },
	{ "`e", "è" },
	{ "`i", "ì" },
	{ "`o", "ò" },
	{ "`u", "ù" },
	{ "a\"", "˝" },
	{ "a-", "¯" },
	{ "a.", "˙" },
	{ "a^", "^" },
	{ "aa", "´" },
	{ "ab", "˘" },
	{ "ac", "¸" },
	{ "ad", "¨" },
	{ "ae", "æ" },
	{ "ah", "ˇ" },
	{ "ao", "˚" },
	{ "aq", "'" },
	{ "a~", "~" },
	{ "bq", "‚" },
	{ "cq", "’" },
	{ "dq", "\"" },
	{ "em", "—" },
	{ "en", "–" },
	{ "fc", "›" },
	{ "ff", "ff" },
	{ "fi", "fi" },
	{ "fl", "fl" },
	{ "fo", "‹" },
	{ "ga", "`" },
	{ "ha", "^" },
	{ "ho", "˛" },
	{ "hy", "‐" },
	{ "ij", "ĳ" },
	{ "lq", "“" },
	{ "oA", "Å" },
	{ "oa", "å" },
	{ "oe", "œ" },
	{ "oq", "‘" },
	{ "r!", "¡" },
	{ "r?", "¿" },
	{ "rq", "”" },
	{ "ss", "ß" },
	{ "ti", "~" },
	{ "vS", "Š" },
	{ "vZ", "Ž" },
	{ "vs", "š" },
	{ "vz", "ž" },
	{ "~A", "Ã" },
	{ "~N", "Ñ" },
	{ "~O", "Õ" },
	{ "~a", "ã" },
	{ "~n", "ñ" },
	{ "~o", "õ" }
};

static const struct macro perldocs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from Pod/Man.pm.
	 */
	{ "--", "-" },
	{ "Aq", "'" },
	{ "C'", "'" },
	{ "C+", "C++" },
	{ "C`", "`" },
	{ "L\"", "\"" },
	{ "PI", "π" },
	{ "R\"", "\"" }
};

static void add_str_to_whatis (const char *string, size_t length);
static void add_char_to_whatis (unsigned char c);
static void add_separator_to_whatis (void);
static void add_wordn_to_whatis (const char *string, size_t length);
static void add_word_to_whatis (const char *string);
static void add_glyph_to_whatis (const char *string, size_t length);
static void add_perldoc_to_whatis (const char *string, size_t length);
static void mdoc_text (const char *string);
static void newline_found (void);

static char newname[MAX_NAME];
static char *p_name;
static const char *fname;
static char filters[MAX_FILTERS];

static int fill_mode;
static int waiting_for_quote;

static pipeline *decomp;

#define YY_INPUT(buf,result,max_size) { \
	size_t size = max_size; \
	const char *block = pipeline_read (decomp, &size); \
	if (block && size != 0) { \
		memcpy (buf, block, size); \
		buf[size] = '\0'; \
		result = size; \
	} else \
		result = YY_NULL; \
}
#define YY_NO_INPUT
#line 2845 "lexgrog.c"

#line 292 "lexgrog.l"
 /* Please add to this list if you know how. */
 /* Note that, since flex only supports UTF-8 by accident, character classes
  * including non-ASCII characters must be written out as (a|b|c|d) rather
  * than [abcd].
  */
 /* NOME also works for gl, pt */
 /* eptgrv : eqn, pic, tbl, grap, refer, vgrind */
#line 2855 "lexgrog.c"

#define INITIAL 0
#define MAN_PRENAME 1
#define MAN_NAME 2
#define MAN_DESC 3
#define MAN_DESC_AT 4
#define MAN_DESC_BSX 5
#define MAN_DESC_BX 6
#define MAN_DESC_BX_RELEASE 7
#define MAN_DESC_DQ 8
#define MAN_DESC_FX 9
#define MAN_DESC_NX 10
#define MAN_DESC_OX 11
#define CAT_NAME 12
#define CAT_FILE 13
#define MAN_FILE 14
#define CAT_REST 15
#define MAN_REST 16
#define FORCE_EXIT 17

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals ( void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy ( void );

int yyget_debug ( void );

void yyset_debug ( int debug_flag  );

YY_EXTRA_TYPE yyget_extra ( void );

void yyset_extra ( YY_EXTRA_TYPE user_defined  );

FILE *yyget_in ( void );

void yyset_in  ( FILE * _in_str  );

FILE *yyget_out ( void );

void yyset_out  ( FILE * _out_str  );

			int yyget_leng ( void );

char *yyget_text ( void );

int yyget_lineno ( void );

void yyset_lineno ( int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap ( void );
#else
extern int yywrap ( void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
#line 339 "lexgrog.l"


 /* begin NAME section processing */
#line 3091 "lexgrog.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1436 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 1435 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 342 "lexgrog.l"
BEGIN (MAN_PRENAME);
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 343 "lexgrog.l"
BEGIN (CAT_NAME);
	YY_BREAK
/* general text matching */

case 3:
#line 348 "lexgrog.l"
case 4:
#line 349 "lexgrog.l"
case 5:
#line 350 "lexgrog.l"
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 350 "lexgrog.l"

	YY_BREAK


case 7:
#line 355 "lexgrog.l"
case 8:
#line 356 "lexgrog.l"
case 9:
/* rule 9 can match eol */
#line 357 "lexgrog.l"
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
#line 357 "lexgrog.l"

	YY_BREAK


case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 361 "lexgrog.l"
filters[TBL_FILTER] = 't';
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 362 "lexgrog.l"
filters[EQN_FILTER] = 'e';
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 363 "lexgrog.l"
filters[PIC_FILTER] = 'p';
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 364 "lexgrog.l"
filters[GRAP_FILTER] = 'g';
	YY_BREAK
case 15:
/* rule 15 can match eol */
#line 366 "lexgrog.l"
case 16:
/* rule 16 can match eol */
YY_RULE_SETUP
#line 366 "lexgrog.l"
filters[REF_FILTER] = 'r';
	YY_BREAK
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 367 "lexgrog.l"
filters[VGRIND_FILTER] = 'v';
	YY_BREAK

case YY_STATE_EOF(MAN_REST):
#line 369 "lexgrog.l"
{	/* exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 373 "lexgrog.l"

	YY_BREAK
/* rules to end NAME section processing */
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 376 "lexgrog.l"
{	/* forced exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 20:
/* rule 20 can match eol */
#line 382 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_PRENAME):
#line 382 "lexgrog.l"
{	/* no NAME at all */
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* need to match whole string so that we beat the following roff catch-all,
    so use yyless to push back the name */

case 21:
/* rule 21 can match eol */
#line 391 "lexgrog.l"
case 22:
/* rule 22 can match eol */
#line 392 "lexgrog.l"
case 23:
/* rule 23 can match eol */
#line 393 "lexgrog.l"
case 24:
/* rule 24 can match eol */
#line 394 "lexgrog.l"
case 25:
/* rule 25 can match eol */
#line 395 "lexgrog.l"
case 26:
/* rule 26 can match eol */
YY_RULE_SETUP
#line 395 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* Skip over initial roff requests in NAME section. The use of yyless here
    is evil. */
case 27:
/* rule 27 can match eol */
YY_RULE_SETUP
#line 403 "lexgrog.l"

	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 405 "lexgrog.l"
yyless (1);
	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 407 "lexgrog.l"
{
	yyless (0);
	BEGIN (MAN_NAME);
}
	YY_BREAK

case 30:
/* rule 30 can match eol */
#line 414 "lexgrog.l"
case 31:
/* rule 31 can match eol */
#line 415 "lexgrog.l"
case 32:
/* rule 32 can match eol */
#line 416 "lexgrog.l"
case 33:
/* rule 33 can match eol */
#line 417 "lexgrog.l"
case 34:
/* rule 34 can match eol */
#line 418 "lexgrog.l"
case 35:
/* rule 35 can match eol */
#line 419 "lexgrog.l"
case 36:
/* rule 36 can match eol */
#line 420 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_NAME):
YY_RULE_SETUP
case YY_STATE_EOF(MAN_DESC):
#line 420 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (MAN_REST);
	}
	YY_BREAK


case 37:
/* rule 37 can match eol */
#line 428 "lexgrog.l"
case 38:
/* rule 38 can match eol */
#line 429 "lexgrog.l"
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 429 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (CAT_REST);
		yyterminate ();
	}
	YY_BREAK

/* ROFF request removal */

/* some include quoting; dealing with this is unpleasant */
case 40:
/* rule 40 can match eol */
YY_RULE_SETUP
#line 439 "lexgrog.l"
{
		newline_found ();
		waiting_for_quote = 1;
	}
	YY_BREAK
case 41:
/* rule 41 can match eol */
#line 445 "lexgrog.l"
case 42:
/* rule 42 can match eol */
#line 446 "lexgrog.l"
case 43:
/* rule 43 can match eol */
#line 447 "lexgrog.l"
case 44:
/* rule 44 can match eol */
#line 448 "lexgrog.l"
case 45:
/* rule 45 can match eol */
#line 449 "lexgrog.l"
case 46:
/* rule 46 can match eol */
#line 450 "lexgrog.l"
case 47:
/* rule 47 can match eol */
#line 451 "lexgrog.l"
case 48:
/* rule 48 can match eol */
#line 452 "lexgrog.l"
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 452 "lexgrog.l"
{	/* per line comments */
		newline_found ();
	}
	YY_BREAK

/* No-op requests */

case 50:
/* rule 50 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 459 "lexgrog.l"
newline_found ();
	YY_BREAK
case 51:
/* rule 51 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 460 "lexgrog.l"
newline_found ();
	YY_BREAK

/* Toggle fill mode */

case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 465 "lexgrog.l"
fill_mode = 0;
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 466 "lexgrog.l"
fill_mode = 1;
	YY_BREAK

case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 469 "lexgrog.l"
/* strip continuations */
	YY_BREAK
/* convert to DASH */

case 55:
/* rule 55 can match eol */
#line 474 "lexgrog.l"
case 56:
/* rule 56 can match eol */
#line 475 "lexgrog.l"
case 57:
/* rule 57 can match eol */
#line 476 "lexgrog.l"
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 476 "lexgrog.l"
{
		add_separator_to_whatis ();
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 481 "lexgrog.l"
add_separator_to_whatis ();
	YY_BREAK
/* escape sequences and special characters */

case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 485 "lexgrog.l"
add_char_to_whatis ('\\');
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 486 "lexgrog.l"
add_char_to_whatis ('\'');
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 487 "lexgrog.l"
add_char_to_whatis ('`');
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 488 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 489 "lexgrog.l"
add_char_to_whatis ('.');
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 490 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 491 "lexgrog.l"
add_char_to_whatis ('_');
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 492 "lexgrog.l"
add_char_to_whatis ('\t');
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 494 "lexgrog.l"
/* various useless control chars */
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 495 "lexgrog.l"
/* various inline functions */
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 497 "lexgrog.l"
/* interpolate arg */
	YY_BREAK
/* roff named glyphs */
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 500 "lexgrog.l"
add_glyph_to_whatis (yytext + 2, 2);
	YY_BREAK
/* perldoc strings */
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 502 "lexgrog.l"
add_perldoc_to_whatis (yytext + 3, 2);
	YY_BREAK
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 503 "lexgrog.l"
add_perldoc_to_whatis (yytext + 2, 1);
	YY_BREAK
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 505 "lexgrog.l"
/* comment */
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 507 "lexgrog.l"
/* font changes */
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 508 "lexgrog.l"
/* mark input place in register */
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 510 "lexgrog.l"
/* interpolate number register */
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 511 "lexgrog.l"
/* overstrike chars */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 513 "lexgrog.l"
/* size changes */
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 514 "lexgrog.l"
/* width of string */
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 516 "lexgrog.l"
/* catch all */
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 518 "lexgrog.l"
/* function() in hpux */
	YY_BREAK

/* some people rather ambitiously use non-trivial mdoc macros in NAME
    sections; cope with those that have been seen in the wild, and a few
    more */

case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 525 "lexgrog.l"
BEGIN (MAN_DESC_AT);
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 526 "lexgrog.l"
BEGIN (MAN_DESC_BSX);
	YY_BREAK
case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 527 "lexgrog.l"
BEGIN (MAN_DESC_BX);
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 528 "lexgrog.l"
BEGIN (MAN_DESC_FX);
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 529 "lexgrog.l"
BEGIN (MAN_DESC_NX);
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 530 "lexgrog.l"
BEGIN (MAN_DESC_OX);
	YY_BREAK
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
#line 531 "lexgrog.l"
add_word_to_whatis ("UNIX");
	YY_BREAK
case 90:
/* rule 90 can match eol */
YY_RULE_SETUP
#line 533 "lexgrog.l"
{
		add_word_to_whatis ("\"");
		BEGIN (MAN_DESC_DQ);
	}
	YY_BREAK


case 91:
YY_RULE_SETUP
#line 540 "lexgrog.l"
mdoc_text ("Version 32V AT&T UNIX");
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 541 "lexgrog.l"
mdoc_text ("Version 1 AT&T UNIX");
	YY_BREAK
case 93:
YY_RULE_SETUP
#line 542 "lexgrog.l"
mdoc_text ("Version 2 AT&T UNIX");
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 543 "lexgrog.l"
mdoc_text ("Version 3 AT&T UNIX");
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 544 "lexgrog.l"
mdoc_text ("Version 4 AT&T UNIX");
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 545 "lexgrog.l"
mdoc_text ("Version 5 AT&T UNIX");
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 546 "lexgrog.l"
mdoc_text ("Version 6 AT&T UNIX");
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 547 "lexgrog.l"
mdoc_text ("Version 7 AT&T UNIX");
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 548 "lexgrog.l"
mdoc_text ("AT&T System V UNIX");
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 549 "lexgrog.l"
mdoc_text ("AT&T System V.1 UNIX");
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 550 "lexgrog.l"
mdoc_text ("AT&T System V.2 UNIX");
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 551 "lexgrog.l"
mdoc_text ("AT&T System V.3 UNIX");
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 552 "lexgrog.l"
mdoc_text ("AT&T System V.4 UNIX");
	YY_BREAK
case 104:
/* rule 104 can match eol */
YY_RULE_SETUP
#line 553 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("AT&T UNIX");
	}
	YY_BREAK


case 105:
YY_RULE_SETUP
#line 560 "lexgrog.l"
{
		add_word_to_whatis ("BSD/OS");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
#line 565 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD/OS");
	}
	YY_BREAK


case 107:
YY_RULE_SETUP
#line 572 "lexgrog.l"
mdoc_text ("BSD (currently in alpha test)");
	YY_BREAK
case 108:
YY_RULE_SETUP
#line 573 "lexgrog.l"
mdoc_text ("BSD (currently in beta test)");
	YY_BREAK
case 109:
YY_RULE_SETUP
#line 574 "lexgrog.l"
mdoc_text ("BSD (currently under development");
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 575 "lexgrog.l"
{
		add_wordn_to_whatis (yytext, yyleng);
		add_str_to_whatis ("BSD", 3);
		BEGIN (MAN_DESC_BX_RELEASE);
	}
	YY_BREAK
case 111:
/* rule 111 can match eol */
YY_RULE_SETUP
#line 580 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD");
	}
	YY_BREAK


case 112:
YY_RULE_SETUP
#line 587 "lexgrog.l"
{
		add_str_to_whatis ("-Reno", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 113:
YY_RULE_SETUP
#line 591 "lexgrog.l"
{
		add_str_to_whatis ("-Tahoe", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 114:
YY_RULE_SETUP
#line 595 "lexgrog.l"
{
		add_str_to_whatis ("-Lite", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 599 "lexgrog.l"
{
		add_str_to_whatis ("-Lite2", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 116:
/* rule 116 can match eol */
YY_RULE_SETUP
#line 603 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 117:
YY_RULE_SETUP
#line 609 "lexgrog.l"
{
	add_str_to_whatis (yytext, yyleng);
	add_char_to_whatis ('"');
	BEGIN (MAN_DESC);
}
	YY_BREAK

case 118:
YY_RULE_SETUP
#line 616 "lexgrog.l"
{
		add_word_to_whatis ("FreeBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 119:
/* rule 119 can match eol */
YY_RULE_SETUP
#line 621 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("FreeBSD");
	}
	YY_BREAK


case 120:
YY_RULE_SETUP
#line 628 "lexgrog.l"
{
		add_word_to_whatis ("NetBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 121:
/* rule 121 can match eol */
YY_RULE_SETUP
#line 633 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("NetBSD");
	}
	YY_BREAK


case 122:
YY_RULE_SETUP
#line 640 "lexgrog.l"
{
		add_word_to_whatis ("OpenBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 645 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("OpenBSD");
	}
	YY_BREAK

/* collapse spaces, escaped spaces, tabs, newlines to a single space */
case 124:
/* rule 124 can match eol */
YY_RULE_SETUP
#line 652 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
/* a ROFF break request, a paragraph request, or an indentation change
    usually means we have multiple whatis definitions, provide a separator
    for later processing */

case 125:
/* rule 125 can match eol */
#line 659 "lexgrog.l"
case 126:
/* rule 126 can match eol */
#line 660 "lexgrog.l"
case 127:
/* rule 127 can match eol */
#line 661 "lexgrog.l"
case 128:
/* rule 128 can match eol */
#line 662 "lexgrog.l"
case 129:
/* rule 129 can match eol */
#line 663 "lexgrog.l"
case 130:
/* rule 130 can match eol */
#line 664 "lexgrog.l"
case 131:
/* rule 131 can match eol */
#line 665 "lexgrog.l"
case 132:
/* rule 132 can match eol */
YY_RULE_SETUP
#line 665 "lexgrog.l"
{
		add_char_to_whatis ((char) 0x11);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* any other roff request we don't recognise terminates definitions */
case 133:
/* rule 133 can match eol */
YY_RULE_SETUP
#line 672 "lexgrog.l"
{
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* pass words as a chunk. speed optimization */
case 134:
YY_RULE_SETUP
#line 678 "lexgrog.l"
add_str_to_whatis (yytext, yyleng);
	YY_BREAK
/* normalise the comma (,) separators */
case 135:
/* rule 135 can match eol */
#line 682 "lexgrog.l"
case 136:
/* rule 136 can match eol */
YY_RULE_SETUP
#line 682 "lexgrog.l"
add_str_to_whatis (", ", 2);
	YY_BREAK
case 137:
/* rule 137 can match eol */
YY_RULE_SETUP
#line 684 "lexgrog.l"
{
	newline_found ();
	add_char_to_whatis (yytext[yyleng - 1]);
}
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 689 "lexgrog.l"
add_char_to_whatis (*yytext);
	YY_BREAK
/* default EOF rule */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(MAN_DESC_AT):
case YY_STATE_EOF(MAN_DESC_BSX):
case YY_STATE_EOF(MAN_DESC_BX):
case YY_STATE_EOF(MAN_DESC_BX_RELEASE):
case YY_STATE_EOF(MAN_DESC_DQ):
case YY_STATE_EOF(MAN_DESC_FX):
case YY_STATE_EOF(MAN_DESC_NX):
case YY_STATE_EOF(MAN_DESC_OX):
case YY_STATE_EOF(CAT_NAME):
case YY_STATE_EOF(CAT_FILE):
case YY_STATE_EOF(MAN_FILE):
case YY_STATE_EOF(CAT_REST):
case YY_STATE_EOF(FORCE_EXIT):
#line 692 "lexgrog.l"
return 1;
	YY_BREAK
case 139:
YY_RULE_SETUP
#line 694 "lexgrog.l"
ECHO;
	YY_BREAK
#line 4026 "lexgrog.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1436 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1436 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 1435);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (const char * yystr )
{
    
	return yy_scan_bytes( yystr, (int) strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = (yy_size_t) (_yybytes_len + 2);
	buf = (char *) yyalloc( n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (const char* msg )
{
			fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
    
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = NULL;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = NULL;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer( YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 694 "lexgrog.l"


/* print warning and force scanner to terminate */
static void too_big (void)
{
	/* Even though MAX_NAME is a macro expanding to a constant, we
	 * translate it using ngettext anyway because that will make it
	 * easier to change the macro later.
	 */
	error (0, 0,
	       ngettext ("warning: whatis for %s exceeds %d byte, "
			 "truncating.",
			 "warning: whatis for %s exceeds %d bytes, "
			 "truncating.", MAX_NAME),
	       fname, MAX_NAME);

	BEGIN (FORCE_EXIT);
}

/* append a string to newname if enough room */
static void add_str_to_whatis (const char *string, size_t length)
{
	if (p_name - newname + length >= MAX_NAME)
		too_big ();
	else {
		(void) strncpy (p_name, string, length);
		p_name += length;
	}
} 

/* append a char to newname if enough room */
static void add_char_to_whatis (unsigned char c)
{
	if (p_name - newname + 1 >= MAX_NAME)
		too_big ();
	else if (waiting_for_quote && c == '"')
		waiting_for_quote = 0;
	else
		*p_name++ = c;
}

/* append the " - " separator to newname, trimming the first space if one's
 * already there
 */
static void add_separator_to_whatis (void)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	add_str_to_whatis ("- ", 2);
}

/* append a word to newname if enough room, ensuring only necessary
   surrounding space */
static void add_wordn_to_whatis (const char *string, size_t length)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	while (length && string[length - 1] == ' ')
		--length;
	if (length)
		add_str_to_whatis (string, length);
}

static void add_word_to_whatis (const char *string)
{
	add_wordn_to_whatis (string, strlen (string));
}

struct compare_macro_key {
	const char *string;
	size_t length;
};

static int compare_macro (const void *left, const void *right)
{
	const struct compare_macro_key *key = left;
	const struct macro *value = right;
	int cmp;

	cmp = strncmp (key->string, value->name, key->length);
	if (cmp)
		return cmp;
	/* equal up to key->length, so value->name must be at least size
	 * key->length + 1
	 */
	else if (value->name[key->length])
		return -1;
	else
		return 0;
}

static void add_macro_to_whatis (const struct macro *macros, size_t n_macros,
				 const char *string, size_t length)
{
	struct compare_macro_key key;
	const struct macro *macro;

	key.string = string;
	key.length = length;
	macro = bsearch (&key, macros, n_macros, sizeof (struct macro),
			 compare_macro);
	if (macro)
		add_str_to_whatis (macro->value, strlen (macro->value));
}

static void add_glyph_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (glyphs, ARRAY_SIZE (glyphs), string, length);
}

static void add_perldoc_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (perldocs, ARRAY_SIZE (perldocs), string, length);
}

static void mdoc_text (const char *string)
{
	add_word_to_whatis (string);
	BEGIN (MAN_DESC);
}

static void newline_found (void)
{
	/* If we are mid p_name and the last added char was not a space,
	 * best add one.
	 */
	if (p_name != newname && *(p_name - 1) != ' ') {
		if (fill_mode)
			add_char_to_whatis (' ');
		else {
			add_char_to_whatis ((char) 0x11);
			BEGIN (MAN_NAME);
		}
	}
	waiting_for_quote = 0;
}

int find_name (const char *file, const char *filename, lexgrog *p_lg,
	       const char *encoding)
{
	int ret;
	pipeline *p;
	char *page_encoding = NULL;

	if (strcmp (file, "-") == 0) {
		p = decompress_fdopen (dup (STDIN_FILENO));
	} else {
		struct stat st;
		char *lang;

		if (stat (file, &st)) {
			error (0, errno, "%s", file);
			return 0;
		}

		if (S_ISDIR (st.st_mode)) {
			error (0, EISDIR, "%s", file);
			return 0;
		}

		drop_effective_privs ();
		p = decompress_open (file);
		if (!p) {
			error (0, errno, _("can't open %s"), file);
			regain_effective_privs ();
			return 0;
		}
		regain_effective_privs ();

		if (!encoding) {
			lang = lang_dir (file);
			page_encoding = get_page_encoding (lang);
			free (lang);
		}
	}
	if (!page_encoding && encoding)
		page_encoding = xstrdup (encoding);
	if (page_encoding)
		add_manconv (p, page_encoding, "UTF-8");
	free (page_encoding);
	if (p_lg->type && *COL) {
		pipecmd *col_cmd;
		col_cmd = pipecmd_new_args (COL, "-b", "-p", "-x", (void *) 0);
		pipecmd_pre_exec (col_cmd, sandbox_load, sandbox_free,
				  sandbox);
		pipeline_command (p, col_cmd);
	}
	pipeline_start (p);

	ret = find_name_decompressed (p, filename, p_lg);
	pipeline_free (p);
	return ret;
}

int find_name_decompressed (pipeline *p, const char *filename, lexgrog *p_lg)
{
	int ret;

	decomp = p;

	fname = filename;
	*(p_name = newname) = '\0';
	memset (filters, '_', sizeof (filters));

	fill_mode = 1;
	waiting_for_quote = 0;

	if (p_lg->type)
		BEGIN (CAT_FILE);
	else
		BEGIN (MAN_FILE);

	drop_effective_privs ();

	yyrestart (NULL);
	ret = yylex ();

	regain_effective_privs ();

	pipeline_wait (decomp);

	if (ret)
		return 0;
	else {
		char f_tmp[MAX_FILTERS];
		int j, k;

		/* wipe out any leading or trailing spaces */
		if (*newname) {
			for (p_name = strchr (newname, '\0');
			     *(p_name - 1) == ' ';
			     p_name--);
			if (*p_name == ' ')
				*p_name = '\0';
		}
		for (p_name = newname; *p_name == ' '; p_name++);
		p_lg->whatis = xstrdup (p_name);
		memset (f_tmp, '\0', MAX_FILTERS);
		f_tmp[0] = '-';
		for (j = k = 0; j < MAX_FILTERS; j++)
			if (filters[j] != '_')
				f_tmp[k++] = filters[j];
		p_lg->filters = xstrdup (f_tmp);
		return p_name[0];
	}
}

